
usprite.o:     file format elf32-littlearm

Disassembly of section .text:

00000000 <_Z11_ClipSpriteRPtS0_iiRiS1_RmS2_>:

// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
static  inline  void  _ClipSprite(u16* &pSrc, u16* &pDst, int iX, int iY, int &iSizeX, int &iSizeY, u32 &uSrc, u32 &uDst)
{
       0:	e92d47f0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, lr}
       4:	e59d9024 	ldr	r9, [sp, #36]

  //  falta por arreglar esto
  iX &=~1;

  //  clip Y
  int yb = 0; int ye = iSizeY;
  if(iY<0)
       8:	e253c000 	subs	ip, r3, #0	; 0x0
       c:	e5993000 	ldr	r3, [r9]
      10:	e3a05000 	mov	r5, #0	; 0x0
    yb -= iY, iY = 0;
      14:	b26c5000 	rsblt	r5, ip, #0	; 0x0
      18:	e1a08000 	mov	r8, r0
      1c:	b3a0c000 	movlt	ip, #0	; 0x0
  if(iY+(ye-yb) > 320)
      20:	e0650003 	rsb	r0, r5, r3
      24:	e3c24001 	bic	r4, r2, #1	; 0x1
      28:	e1a07001 	mov	r7, r1
      2c:	e080200c 	add	r2, r0, ip
    ye = 320-(iY+yb);
      30:	e08c1005 	add	r1, ip, r5
      34:	e59da020 	ldr	sl, [sp, #32]
      38:	e3520d05 	cmp	r2, #320	; 0x140
      3c:	e261ed05 	rsb	lr, r1, #320	; 0x140
      40:	c065000e 	rsbgt	r0, r5, lr

  //  clip X
  int xb = 0; int xe = iSizeX;
      44:	e59ae000 	ldr	lr, [sl]
  if(iX<0)
      48:	e3540000 	cmp	r4, #0	; 0x0
      4c:	e3a01000 	mov	r1, #0	; 0x0
    xb -= iX, iX = 0;
      50:	b2641000 	rsblt	r1, r4, #0	; 0x0
  if(iX+(xe-xb) > 240)
    xe = 240-(iX+xb);

  pDst += iY*240    + iX;
      54:	e06c620c 	rsb	r6, ip, ip, lsl #4
      58:	b3a04000 	movlt	r4, #0	; 0x0
      5c:	e061c00e 	rsb	ip, r1, lr
      60:	e08c3004 	add	r3, ip, r4
      64:	e0842001 	add	r2, r4, r1
      68:	e35300f0 	cmp	r3, #240	; 0xf0
      6c:	e26230f0 	rsb	r3, r2, #240	; 0xf0
      70:	c061c003 	rsbgt	ip, r1, r3
  pSrc += yb*iSizeX + xb;
      74:	e025159e 	mla	r5, lr, r5, r1
      78:	e5971000 	ldr	r1, [r7]
      7c:	e0846206 	add	r6, r4, r6, lsl #4
      80:	e0812086 	add	r2, r1, r6, lsl #1
      84:	e5872000 	str	r2, [r7]

  //  salto
  uSrc = iSizeX;
      88:	e59d3028 	ldr	r3, [sp, #40]
      8c:	e5981000 	ldr	r1, [r8]
      90:	e583e000 	str	lr, [r3]
  uDst = 240;
      94:	e59d302c 	ldr	r3, [sp, #44]
      98:	e0812085 	add	r2, r1, r5, lsl #1
      9c:	e3a010f0 	mov	r1, #240	; 0xf0
  
  //  tamao
  iSizeX = xe-xb;
      a0:	e58ac000 	str	ip, [sl]
      a4:	e5882000 	str	r2, [r8]
      a8:	e5831000 	str	r1, [r3]
  iSizeY = ye-yb;
      ac:	e5890000 	str	r0, [r9]
      b0:	e8bd87f0 	ldmia	sp!, {r4, r5, r6, r7, r8, r9, sl, pc}

000000b4 <_Z14uS_DrawSpriteHPtssS_>:
}


// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
template<typename OP> inline
void _DrawSprite  (u16 *pSprite, u16 *pBuffer, int iX, int iY, int iSizeX, int iSizeY, u32 uTran, u32 uAlpha)
{
  u32   uSrc,uDst;
  _ClipSprite(pSprite, pBuffer, iX, iY, iSizeX, iSizeY, uSrc, uDst);

  if(iSizeX<=0 || iSizeY<=0)
    return;

  uSrc>>=1;
  uDst>>=1;

  u32*  pSrc = (u32*)(pSprite+iSizeX);
  u32*  pDst = (u32*)(pBuffer+iSizeX);

  iSizeX=-(iSizeX>>1);

  uTran |= uTran<<16;

  while(iSizeY--)
  {
    int xx = iSizeX;
    while(xx)
    {
      OP::Make11(pSrc[xx],pDst[xx],uTran,uAlpha);
      ++xx;
    }
    pDst += uDst;
    pSrc += uSrc;
  }
}


// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
void uS_DrawSprite    (u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 xsize, u16 ysize)
{
  _DrawSprite<OP_Set>(sprite, framebuffer, put_x, put_y, xsize, ysize, 0, 0);
}


void uS_DrawSpriteA   ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 xsize, u16 ysize)
{
  _DrawSprite<OP_Add>(sprite, framebuffer, put_x, put_y, xsize, ysize, 0, 0);
}


void uS_DrawSpriteS   ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 xsize, u16 ysize)
{
  _DrawSprite<OP_Sub>(sprite, framebuffer, put_x, put_y, xsize, ysize, 0, 0);
}


void uS_DrawSpriteB   ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 xsize, u16 ysize, u8 alpha)
{
  _DrawSprite<OP_Blend>(sprite, framebuffer, put_x, put_y, xsize, ysize, 0, alpha);
}


void uS_DrawSpriteT   ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans, u16 xsize, u16 ysize)
{
  _DrawSprite<OP_SetT>(sprite, framebuffer, put_x, put_y, xsize, ysize, trans, 0);
}


void uS_DrawSpriteTA  ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans, u16 xsize, u16 ysize)
{
  _DrawSprite<OP_AddT>(sprite, framebuffer, put_x, put_y, xsize, ysize, trans, 0);
}


void uS_DrawSpriteTS  ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans, u16 xsize, u16 ysize)
{
  _DrawSprite<OP_SubT>(sprite, framebuffer, put_x, put_y, xsize, ysize, trans, 0);
}


void uS_DrawSpriteTB  ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans, u16 xsize, u16 ysize, u8 alpha)
{
  _DrawSprite<OP_BlendT>(sprite, framebuffer, put_x, put_y, xsize, ysize, trans, alpha);
}


//  compatibilidad MrMirko
// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
typedef struct {
   char magic[4];
   u16 size_x;
   u16 size_y;
   u16 info;
   u16 alpha;
   //u16 raw[0];
} SHEADER;
/*
info:
format :[0-3]   0000 RGB  16 Format RRRRRGGGGGBBBBB-   normal sprite data
                0001 RGB  16 Format RRRRRGGGGGBBBBB-   normal sprite data + blend in data
                0010 ARGB 32 Format -----------AAAAARRRRRGGGGGBBBBB-
                0011 ...

reserved:[4-5]    reserved, always 0
rotate:6          0 Sprite is rotated  ( 90 deg clockwise )
                  1 Sprite is not rotated
alpha:7           0 Alpha/Blend disable
                  1 Alpha/Blend enabled
*/

// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
void uS_DrawSpriteH   ( u16 *sprite, short put_x, short put_y, u16 *framebuffer)
{
      b4:	e1a0c00d 	mov	ip, sp
      b8:	e92dd870 	stmdb	sp!, {r4, r5, r6, fp, ip, lr, pc}
      bc:	e24cb004 	sub	fp, ip, #4	; 0x4
      c0:	e24dd028 	sub	sp, sp, #40	; 0x28
      c4:	e1a0c000 	mov	ip, r0
      c8:	e1dc40b6 	ldrh	r4, [ip, #6]
      cc:	e1dce0b4 	ldrh	lr, [ip, #4]
      d0:	e1a00802 	mov	r0, r2, lsl #16
      d4:	e1a01801 	mov	r1, r1, lsl #16
      d8:	e28cc00c 	add	ip, ip, #12	; 0xc
      dc:	e50b4028 	str	r4, [fp, #-40]
      e0:	e24b4024 	sub	r4, fp, #36	; 0x24
      e4:	e50b3020 	str	r3, [fp, #-32]
      e8:	e1a02841 	mov	r2, r1, asr #16
      ec:	e1a03840 	mov	r3, r0, asr #16
      f0:	e50bc01c 	str	ip, [fp, #-28]
      f4:	e24b001c 	sub	r0, fp, #28	; 0x1c
      f8:	e50be024 	str	lr, [fp, #-36]
      fc:	e58d4000 	str	r4, [sp]
     100:	e24be028 	sub	lr, fp, #40	; 0x28
     104:	e24bc02c 	sub	ip, fp, #44	; 0x2c
     108:	e24b1020 	sub	r1, fp, #32	; 0x20
     10c:	e24b4030 	sub	r4, fp, #48	; 0x30
     110:	e58de004 	str	lr, [sp, #4]
     114:	e58dc008 	str	ip, [sp, #8]
     118:	e58d400c 	str	r4, [sp, #12]
     11c:	ebfffffe 	bl	11c <_Z14uS_DrawSpriteHPtssS_+0x68>
     120:	e51b0024 	ldr	r0, [fp, #-36]
     124:	e3500000 	cmp	r0, #0	; 0x0
     128:	da00006e 	ble	2e8 <_Z15uS_DrawSpriteHAPtssS_+0x14>
     12c:	e51b3028 	ldr	r3, [fp, #-40]
     130:	e3530000 	cmp	r3, #0	; 0x0
     134:	da00006e 	ble	2f4 <_Z15uS_DrawSpriteHAPtssS_+0x20>
     138:	e51be02c 	ldr	lr, [fp, #-44]
     13c:	e51b4030 	ldr	r4, [fp, #-48]
     140:	e2436001 	sub	r6, r3, #1	; 0x1
     144:	e1a02080 	mov	r2, r0, lsl #1
     148:	e1a0c0c0 	mov	ip, r0, asr #1
     14c:	e51b301c 	ldr	r3, [fp, #-28]
     150:	e51b0020 	ldr	r0, [fp, #-32]
     154:	e1a050ae 	mov	r5, lr, lsr #1
     158:	e3760001 	cmn	r6, #1	; 0x1
     15c:	e1a0e0a4 	mov	lr, r4, lsr #1
     160:	e26c4000 	rsb	r4, ip, #0	; 0x0
     164:	e0821003 	add	r1, r2, r3
     168:	e082c000 	add	ip, r2, r0
     16c:	e50b502c 	str	r5, [fp, #-44]
     170:	e50be030 	str	lr, [fp, #-48]
     174:	e50b4024 	str	r4, [fp, #-36]
     178:	e1a02006 	mov	r2, r6
     17c:	050b6028 	streq	r6, [fp, #-40]
     180:	0a00006e 	beq	340 <_Z15uS_DrawSpriteHAPtssS_+0x6c>
     184:	e2540000 	subs	r0, r4, #0	; 0x0
     188:	0a000067 	beq	32c <_Z15uS_DrawSpriteHAPtssS_+0x58>
  };
  struct  SetTwice
  {
    static  inline  unsigned Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
     18c:	e7915100 	ldr	r5, [r1, r0, lsl #2]
     190:	e78c5100 	str	r5, [ip, r0, lsl #2]
     194:	e2900001 	adds	r0, r0, #1	; 0x1
     198:	1a000061 	bne	324 <_Z15uS_DrawSpriteHAPtssS_+0x50>
     19c:	e51b502c 	ldr	r5, [fp, #-44]
     1a0:	e51be030 	ldr	lr, [fp, #-48]
     1a4:	e2423001 	sub	r3, r2, #1	; 0x1
     1a8:	e3730001 	cmn	r3, #1	; 0x1
     1ac:	e08cc10e 	add	ip, ip, lr, lsl #2
     1b0:	e0811105 	add	r1, r1, r5, lsl #2
     1b4:	e1a02003 	mov	r2, r3
     1b8:	1a00005f 	bne	33c <_Z15uS_DrawSpriteHAPtssS_+0x68>
     1bc:	e50b3028 	str	r3, [fp, #-40]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_Set>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, 0, 0);
}
     1c0:	e24bd018 	sub	sp, fp, #24	; 0x18
     1c4:	e89da870 	ldmia	sp, {r4, r5, r6, fp, sp, pc}

000001c8 <_Z13uS_DrawSpritePtssS_tt>:
     1c8:	e1a0c00d 	mov	ip, sp
     1cc:	e92dd870 	stmdb	sp!, {r4, r5, r6, fp, ip, lr, pc}
     1d0:	e24cb004 	sub	fp, ip, #4	; 0x4
     1d4:	e24dd028 	sub	sp, sp, #40	; 0x28
     1d8:	e1db40b8 	ldrh	r4, [fp, #8]
     1dc:	e1dbe0b4 	ldrh	lr, [fp, #4]
     1e0:	e1a0c802 	mov	ip, r2, lsl #16
     1e4:	e1a01801 	mov	r1, r1, lsl #16
     1e8:	e50b4028 	str	r4, [fp, #-40]
     1ec:	e24b4024 	sub	r4, fp, #36	; 0x24
     1f0:	e50b001c 	str	r0, [fp, #-28]
     1f4:	e50b3020 	str	r3, [fp, #-32]
     1f8:	e1a02841 	mov	r2, r1, asr #16
     1fc:	e1a0384c 	mov	r3, ip, asr #16
     200:	e24b001c 	sub	r0, fp, #28	; 0x1c
     204:	e50be024 	str	lr, [fp, #-36]
     208:	e58d4000 	str	r4, [sp]
     20c:	e24be028 	sub	lr, fp, #40	; 0x28
     210:	e24bc02c 	sub	ip, fp, #44	; 0x2c
     214:	e24b1020 	sub	r1, fp, #32	; 0x20
     218:	e24b4030 	sub	r4, fp, #48	; 0x30
     21c:	e58de004 	str	lr, [sp, #4]
     220:	e58dc008 	str	ip, [sp, #8]
     224:	e58d400c 	str	r4, [sp, #12]
     228:	ebfffffe 	bl	228 <_Z13uS_DrawSpritePtssS_tt+0x60>
     22c:	e51b0024 	ldr	r0, [fp, #-36]
     230:	e3500000 	cmp	r0, #0	; 0x0
     234:	da0000b1 	ble	500 <_Z14uS_DrawSpriteAPtssS_tt+0xa0>
     238:	e51b3028 	ldr	r3, [fp, #-40]
     23c:	e3530000 	cmp	r3, #0	; 0x0
     240:	da0000b1 	ble	50c <_Z14uS_DrawSpriteAPtssS_tt+0xac>
     244:	e51be02c 	ldr	lr, [fp, #-44]
     248:	e51b4030 	ldr	r4, [fp, #-48]
     24c:	e2436001 	sub	r6, r3, #1	; 0x1
     250:	e1a02080 	mov	r2, r0, lsl #1
     254:	e1a0c0c0 	mov	ip, r0, asr #1
     258:	e51b301c 	ldr	r3, [fp, #-28]
     25c:	e51b0020 	ldr	r0, [fp, #-32]
     260:	e1a050ae 	mov	r5, lr, lsr #1
     264:	e3760001 	cmn	r6, #1	; 0x1
     268:	e1a0e0a4 	mov	lr, r4, lsr #1
     26c:	e26c4000 	rsb	r4, ip, #0	; 0x0
     270:	e0821003 	add	r1, r2, r3
     274:	e082c000 	add	ip, r2, r0
     278:	e50b502c 	str	r5, [fp, #-44]
     27c:	e50be030 	str	lr, [fp, #-48]
     280:	e50b4024 	str	r4, [fp, #-36]
     284:	e1a02006 	mov	r2, r6
     288:	050b6028 	streq	r6, [fp, #-40]
     28c:	0a0000b1 	beq	558 <_Z14uS_DrawSpriteAPtssS_tt+0xf8>
     290:	e2540000 	subs	r0, r4, #0	; 0x0
     294:	0a0000aa 	beq	544 <_Z14uS_DrawSpriteAPtssS_tt+0xe4>
  };
  struct  SetTwice
  {
    static  inline  unsigned Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
     298:	e7915100 	ldr	r5, [r1, r0, lsl #2]
     29c:	e78c5100 	str	r5, [ip, r0, lsl #2]
     2a0:	e2900001 	adds	r0, r0, #1	; 0x1
     2a4:	1a0000a4 	bne	53c <_Z14uS_DrawSpriteAPtssS_tt+0xdc>
     2a8:	e51b502c 	ldr	r5, [fp, #-44]
     2ac:	e51be030 	ldr	lr, [fp, #-48]
     2b0:	e2423001 	sub	r3, r2, #1	; 0x1
     2b4:	e3730001 	cmn	r3, #1	; 0x1
     2b8:	e08cc10e 	add	ip, ip, lr, lsl #2
     2bc:	e0811105 	add	r1, r1, r5, lsl #2
     2c0:	e1a02003 	mov	r2, r3
     2c4:	1a0000a2 	bne	554 <_Z14uS_DrawSpriteAPtssS_tt+0xf4>
     2c8:	e50b3028 	str	r3, [fp, #-40]
     2cc:	e24bd018 	sub	sp, fp, #24	; 0x18
     2d0:	e89da870 	ldmia	sp, {r4, r5, r6, fp, sp, pc}

000002d4 <_Z15uS_DrawSpriteHAPtssS_>:

void uS_DrawSpriteHA  ( u16 *sprite, short put_x, short put_y, u16 *framebuffer)
{
     2d4:	e1a0c00d 	mov	ip, sp
     2d8:	e92dddf0 	stmdb	sp!, {r4, r5, r6, r7, r8, sl, fp, ip, lr, pc}
     2dc:	e24cb004 	sub	fp, ip, #4	; 0x4
     2e0:	e24dd028 	sub	sp, sp, #40	; 0x28
     2e4:	e1a0c000 	mov	ip, r0
     2e8:	e1dc40b6 	ldrh	r4, [ip, #6]
     2ec:	e1dce0b4 	ldrh	lr, [ip, #4]
     2f0:	e1a00802 	mov	r0, r2, lsl #16
     2f4:	e1a01801 	mov	r1, r1, lsl #16
     2f8:	e28cc00c 	add	ip, ip, #12	; 0xc
     2fc:	e50b4034 	str	r4, [fp, #-52]
     300:	e24b4030 	sub	r4, fp, #48	; 0x30
     304:	e50b302c 	str	r3, [fp, #-44]
     308:	e1a02841 	mov	r2, r1, asr #16
     30c:	e1a03840 	mov	r3, r0, asr #16
     310:	e50bc028 	str	ip, [fp, #-40]
     314:	e50be030 	str	lr, [fp, #-48]
     318:	e58d4000 	str	r4, [sp]
     31c:	e24be034 	sub	lr, fp, #52	; 0x34
     320:	e24bc038 	sub	ip, fp, #56	; 0x38
     324:	e24b0028 	sub	r0, fp, #40	; 0x28
     328:	e24b102c 	sub	r1, fp, #44	; 0x2c
     32c:	e24b403c 	sub	r4, fp, #60	; 0x3c
     330:	e58de004 	str	lr, [sp, #4]
     334:	e58dc008 	str	ip, [sp, #8]
     338:	e58d400c 	str	r4, [sp, #12]
     33c:	ebfffffe 	bl	33c <_Z15uS_DrawSpriteHAPtssS_+0x68>
     340:	e51be030 	ldr	lr, [fp, #-48]
     344:	e35e0000 	cmp	lr, #0	; 0x0
     348:	da000110 	ble	790 <_Z14uS_DrawSpriteSPtssS_tt+0x10>
     34c:	e51b3034 	ldr	r3, [fp, #-52]
     350:	e3530000 	cmp	r3, #0	; 0x0
     354:	da000110 	ble	79c <_Z14uS_DrawSpriteSPtssS_tt+0x1c>
     358:	e51ba038 	ldr	sl, [fp, #-56]
     35c:	e51b803c 	ldr	r8, [fp, #-60]
     360:	e2434001 	sub	r4, r3, #1	; 0x1
     364:	e1a060ce 	mov	r6, lr, asr #1
     368:	e51b702c 	ldr	r7, [fp, #-44]
     36c:	e51b3028 	ldr	r3, [fp, #-40]
     370:	e1a0c0aa 	mov	ip, sl, lsr #1
     374:	e1a000a8 	mov	r0, r8, lsr #1
     378:	e1a0208e 	mov	r2, lr, lsl #1
     37c:	e2668000 	rsb	r8, r6, #0	; 0x0
     380:	e3740001 	cmn	r4, #1	; 0x1
     384:	e0826007 	add	r6, r2, r7
     388:	e50bc038 	str	ip, [fp, #-56]
     38c:	e50b003c 	str	r0, [fp, #-60]
     390:	e0827003 	add	r7, r2, r3
     394:	e50b8030 	str	r8, [fp, #-48]
     398:	e1a0a004 	mov	sl, r4
     39c:	050b4034 	streq	r4, [fp, #-52]
     3a0:	0a000110 	beq	7e8 <_Z14uS_DrawSpriteSPtssS_tt+0x68>
     3a4:	e2585000 	subs	r5, r8, #0	; 0x0
     3a8:	0a000109 	beq	7d4 <_Z14uS_DrawSpriteSPtssS_tt+0x54>
    //  Returns:        The two added colours.
    //  Parameters:     Four 555x colours, The first parameter colurs are added to the second parameter colours..
    //----------------------------------------------------------------------
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
     3ac:	e7974105 	ldr	r4, [r7, r5, lsl #2]
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
     3b0:	e59fc098 	ldr	ip, [pc, #152]	; 450 <.text+0x450>
     3b4:	e7960105 	ldr	r0, [r6, r5, lsl #2]
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
     3b8:	e59fe094 	ldr	lr, [pc, #148]	; 454 <.text+0x454>
     3bc:	e004300c 	and	r3, r4, ip
     3c0:	e1a0100c 	mov	r1, ip
     3c4:	e0001001 	and	r1, r0, r1
      unsigned  t2_b = (c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G2__r2__b2
     3c8:	e1a0c00e 	mov	ip, lr
     3cc:	e1a022a3 	mov	r2, r3, lsr #5
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a + t2_a;                                                     //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b + t2_b;                                                     //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
     3d0:	e59f3080 	ldr	r3, [pc, #128]	; 458 <.text+0x458>
     3d4:	e08222a1 	add	r2, r2, r1, lsr #5
     3d8:	e000e00e 	and	lr, r0, lr
     3dc:	e004c00c 	and	ip, r4, ip
      t2_b &= MASCARA_SAT_B_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
     3e0:	e59f0074 	ldr	r0, [pc, #116]	; 45c <.text+0x45c>
     3e4:	e08cc00e 	add	ip, ip, lr
     3e8:	e0023003 	and	r3, r2, r3
     3ec:	e00c1000 	and	r1, ip, r0
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
     3f0:	e04332a3 	sub	r3, r3, r3, lsr #5
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
     3f4:	e04102a1 	sub	r0, r1, r1, lsr #5
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
     3f8:	e1822003 	orr	r2, r2, r3
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
                                                                                      //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);           //  11xx11xx11xx  * Moves all to its correct place.
     3fc:	e59f1050 	ldr	r1, [pc, #80]	; 454 <.text+0x454>
     400:	e59f3048 	ldr	r3, [pc, #72]	; 450 <.text+0x450>
     404:	e18cc000 	orr	ip, ip, r0
     408:	e1a02282 	mov	r2, r2, lsl #5
     40c:	e0020003 	and	r0, r2, r3
     410:	e00c1001 	and	r1, ip, r1
     414:	e180c001 	orr	ip, r0, r1
     418:	e786c105 	str	ip, [r6, r5, lsl #2]
     41c:	e2955001 	adds	r5, r5, #1	; 0x1
     420:	1a0000e9 	bne	7cc <_Z14uS_DrawSpriteSPtssS_tt+0x4c>
     424:	e51bc038 	ldr	ip, [fp, #-56]
     428:	e51b003c 	ldr	r0, [fp, #-60]
     42c:	e24a3001 	sub	r3, sl, #1	; 0x1
     430:	e3730001 	cmn	r3, #1	; 0x1
     434:	e0866100 	add	r6, r6, r0, lsl #2
     438:	e087710c 	add	r7, r7, ip, lsl #2
     43c:	e1a0a003 	mov	sl, r3
     440:	1a0000e7 	bne	7e4 <_Z14uS_DrawSpriteSPtssS_tt+0x64>
     444:	e50b3034 	str	r3, [fp, #-52]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_Add>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, 0, 0);
}
     448:	e24bd024 	sub	sp, fp, #36	; 0x24
     44c:	e89dadf0 	ldmia	sp, {r4, r5, r6, r7, r8, sl, fp, sp, pc}
     450:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
     454:	07c0f83e 	undefined
     458:	08020040 	stmeqda	r2, {r6}
     45c:	08010040 	stmeqda	r1, {r6}

00000460 <_Z14uS_DrawSpriteAPtssS_tt>:
     460:	e1a0c00d 	mov	ip, sp
     464:	e92dddf0 	stmdb	sp!, {r4, r5, r6, r7, r8, sl, fp, ip, lr, pc}
     468:	e24cb004 	sub	fp, ip, #4	; 0x4
     46c:	e24dd028 	sub	sp, sp, #40	; 0x28
     470:	e1db40b8 	ldrh	r4, [fp, #8]
     474:	e1dbe0b4 	ldrh	lr, [fp, #4]
     478:	e1a0c802 	mov	ip, r2, lsl #16
     47c:	e1a01801 	mov	r1, r1, lsl #16
     480:	e50b4034 	str	r4, [fp, #-52]
     484:	e24b4030 	sub	r4, fp, #48	; 0x30
     488:	e50b0028 	str	r0, [fp, #-40]
     48c:	e50b302c 	str	r3, [fp, #-44]
     490:	e1a02841 	mov	r2, r1, asr #16
     494:	e1a0384c 	mov	r3, ip, asr #16
     498:	e50be030 	str	lr, [fp, #-48]
     49c:	e58d4000 	str	r4, [sp]
     4a0:	e24be034 	sub	lr, fp, #52	; 0x34
     4a4:	e24bc038 	sub	ip, fp, #56	; 0x38
     4a8:	e24b0028 	sub	r0, fp, #40	; 0x28
     4ac:	e24b102c 	sub	r1, fp, #44	; 0x2c
     4b0:	e24b403c 	sub	r4, fp, #60	; 0x3c
     4b4:	e58de004 	str	lr, [sp, #4]
     4b8:	e58dc008 	str	ip, [sp, #8]
     4bc:	e58d400c 	str	r4, [sp, #12]
     4c0:	ebfffffe 	bl	4c0 <_Z14uS_DrawSpriteAPtssS_tt+0x60>
     4c4:	e51be030 	ldr	lr, [fp, #-48]
     4c8:	e35e0000 	cmp	lr, #0	; 0x0
     4cc:	da000171 	ble	a98 <_Z14uS_DrawSpriteBPtssS_tth+0xc>
     4d0:	e51b3034 	ldr	r3, [fp, #-52]
     4d4:	e3530000 	cmp	r3, #0	; 0x0
     4d8:	da000171 	ble	aa4 <_Z14uS_DrawSpriteBPtssS_tth+0x18>
     4dc:	e51b0038 	ldr	r0, [fp, #-56]
     4e0:	e51b803c 	ldr	r8, [fp, #-60]
     4e4:	e2434001 	sub	r4, r3, #1	; 0x1
     4e8:	e1a060ce 	mov	r6, lr, asr #1
     4ec:	e51b702c 	ldr	r7, [fp, #-44]
     4f0:	e51b3028 	ldr	r3, [fp, #-40]
     4f4:	e1a0c0a0 	mov	ip, r0, lsr #1
     4f8:	e1a0208e 	mov	r2, lr, lsl #1
     4fc:	e1a000a8 	mov	r0, r8, lsr #1
     500:	e3740001 	cmn	r4, #1	; 0x1
     504:	e2668000 	rsb	r8, r6, #0	; 0x0
     508:	e50bc038 	str	ip, [fp, #-56]
     50c:	e0826007 	add	r6, r2, r7
     510:	e50b003c 	str	r0, [fp, #-60]
     514:	e0827003 	add	r7, r2, r3
     518:	e50b8030 	str	r8, [fp, #-48]
     51c:	e1a0a004 	mov	sl, r4
     520:	050b4034 	streq	r4, [fp, #-52]
     524:	0a000171 	beq	af0 <_Z14uS_DrawSpriteBPtssS_tth+0x64>
     528:	e2585000 	subs	r5, r8, #0	; 0x0
     52c:	0a00016a 	beq	adc <_Z14uS_DrawSpriteBPtssS_tth+0x50>
    //  Returns:        The two added colours.
    //  Parameters:     Four 555x colours, The first parameter colurs are added to the second parameter colours..
    //----------------------------------------------------------------------
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
     530:	e7974105 	ldr	r4, [r7, r5, lsl #2]
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
     534:	e59fc098 	ldr	ip, [pc, #152]	; 5d4 <.text+0x5d4>
     538:	e7960105 	ldr	r0, [r6, r5, lsl #2]
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
     53c:	e59fe094 	ldr	lr, [pc, #148]	; 5d8 <.text+0x5d8>
     540:	e004300c 	and	r3, r4, ip
     544:	e1a0100c 	mov	r1, ip
     548:	e0001001 	and	r1, r0, r1
      unsigned  t2_b = (c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G2__r2__b2
     54c:	e1a0c00e 	mov	ip, lr
     550:	e1a022a3 	mov	r2, r3, lsr #5
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a + t2_a;                                                     //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b + t2_b;                                                     //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
     554:	e59f3080 	ldr	r3, [pc, #128]	; 5dc <.text+0x5dc>
     558:	e08222a1 	add	r2, r2, r1, lsr #5
     55c:	e000e00e 	and	lr, r0, lr
     560:	e004c00c 	and	ip, r4, ip
      t2_b &= MASCARA_SAT_B_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
     564:	e59f0074 	ldr	r0, [pc, #116]	; 5e0 <.text+0x5e0>
     568:	e08cc00e 	add	ip, ip, lr
     56c:	e0023003 	and	r3, r2, r3
     570:	e00c1000 	and	r1, ip, r0
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
     574:	e04332a3 	sub	r3, r3, r3, lsr #5
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
     578:	e1822003 	orr	r2, r2, r3
     57c:	e04102a1 	sub	r0, r1, r1, lsr #5
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
     580:	e59f304c 	ldr	r3, [pc, #76]	; 5d4 <.text+0x5d4>
                                                                                      //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);           //  11xx11xx11xx  * Moves all to its correct place.
     584:	e59f104c 	ldr	r1, [pc, #76]	; 5d8 <.text+0x5d8>
     588:	e18cc000 	orr	ip, ip, r0
     58c:	e1a02282 	mov	r2, r2, lsl #5
     590:	e0023003 	and	r3, r2, r3
     594:	e00c1001 	and	r1, ip, r1
     598:	e183c001 	orr	ip, r3, r1
     59c:	e786c105 	str	ip, [r6, r5, lsl #2]
     5a0:	e2955001 	adds	r5, r5, #1	; 0x1
     5a4:	1a00014a 	bne	ad4 <_Z14uS_DrawSpriteBPtssS_tth+0x48>
     5a8:	e51bc038 	ldr	ip, [fp, #-56]
     5ac:	e51b003c 	ldr	r0, [fp, #-60]
     5b0:	e24a3001 	sub	r3, sl, #1	; 0x1
     5b4:	e3730001 	cmn	r3, #1	; 0x1
     5b8:	e0866100 	add	r6, r6, r0, lsl #2
     5bc:	e087710c 	add	r7, r7, ip, lsl #2
     5c0:	e1a0a003 	mov	sl, r3
     5c4:	1a000148 	bne	aec <_Z14uS_DrawSpriteBPtssS_tth+0x60>
     5c8:	e50b3034 	str	r3, [fp, #-52]
     5cc:	e24bd024 	sub	sp, fp, #36	; 0x24
     5d0:	e89dadf0 	ldmia	sp, {r4, r5, r6, r7, r8, sl, fp, sp, pc}
     5d4:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
     5d8:	07c0f83e 	undefined
     5dc:	08020040 	stmeqda	r2, {r6}
     5e0:	08010040 	stmeqda	r1, {r6}

000005e4 <_Z15uS_DrawSpriteHSPtssS_>:

void uS_DrawSpriteHS  ( u16 *sprite, short put_x, short put_y, u16 *framebuffer)
{
     5e4:	e1a0c00d 	mov	ip, sp
     5e8:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
     5ec:	e24cb004 	sub	fp, ip, #4	; 0x4
     5f0:	e24dd028 	sub	sp, sp, #40	; 0x28
     5f4:	e1a0c000 	mov	ip, r0
     5f8:	e1dc40b6 	ldrh	r4, [ip, #6]
     5fc:	e1dce0b4 	ldrh	lr, [ip, #4]
     600:	e1a00802 	mov	r0, r2, lsl #16
     604:	e1a01801 	mov	r1, r1, lsl #16
     608:	e28cc00c 	add	ip, ip, #12	; 0xc
     60c:	e50b4038 	str	r4, [fp, #-56]
     610:	e24b4034 	sub	r4, fp, #52	; 0x34
     614:	e50b3030 	str	r3, [fp, #-48]
     618:	e1a02841 	mov	r2, r1, asr #16
     61c:	e1a03840 	mov	r3, r0, asr #16
     620:	e50bc02c 	str	ip, [fp, #-44]
     624:	e50be034 	str	lr, [fp, #-52]
     628:	e58d4000 	str	r4, [sp]
     62c:	e24be038 	sub	lr, fp, #56	; 0x38
     630:	e24bc03c 	sub	ip, fp, #60	; 0x3c
     634:	e24b002c 	sub	r0, fp, #44	; 0x2c
     638:	e24b1030 	sub	r1, fp, #48	; 0x30
     63c:	e24b4040 	sub	r4, fp, #64	; 0x40
     640:	e58de004 	str	lr, [sp, #4]
     644:	e58dc008 	str	ip, [sp, #8]
     648:	e58d400c 	str	r4, [sp, #12]
     64c:	ebfffffe 	bl	64c <_Z15uS_DrawSpriteHSPtssS_+0x68>
     650:	e51be034 	ldr	lr, [fp, #-52]
     654:	e35e0000 	cmp	lr, #0	; 0x0
     658:	da0001d8 	ble	dc0 <_Z14uS_DrawSpriteTPtssS_ttt+0x58>
     65c:	e51b3038 	ldr	r3, [fp, #-56]
     660:	e3530000 	cmp	r3, #0	; 0x0
     664:	da0001d8 	ble	dcc <_Z14uS_DrawSpriteTPtssS_ttt+0x64>
     668:	e51ba03c 	ldr	sl, [fp, #-60]
     66c:	e51b9040 	ldr	r9, [fp, #-64]
     670:	e2434001 	sub	r4, r3, #1	; 0x1
     674:	e1a070ce 	mov	r7, lr, asr #1
     678:	e51b8030 	ldr	r8, [fp, #-48]
     67c:	e51b302c 	ldr	r3, [fp, #-44]
     680:	e1a0c0aa 	mov	ip, sl, lsr #1
     684:	e1a000a9 	mov	r0, r9, lsr #1
     688:	e267a000 	rsb	sl, r7, #0	; 0x0
     68c:	e1a0208e 	mov	r2, lr, lsl #1
     690:	e3740001 	cmn	r4, #1	; 0x1
     694:	e0827008 	add	r7, r2, r8
     698:	e50bc03c 	str	ip, [fp, #-60]
     69c:	e50b0040 	str	r0, [fp, #-64]
     6a0:	e0828003 	add	r8, r2, r3
     6a4:	e50ba034 	str	sl, [fp, #-52]
     6a8:	e1a09004 	mov	r9, r4
     6ac:	050b4038 	streq	r4, [fp, #-56]
     6b0:	0a0001d8 	beq	e18 <_Z14uS_DrawSpriteTPtssS_ttt+0xb0>
     6b4:	e25a6000 	subs	r6, sl, #0	; 0x0
     6b8:	0a0001d1 	beq	e04 <_Z14uS_DrawSpriteTPtssS_ttt+0x9c>
    //  Returns:        The two added colours.
    //  Parameters:     Four 555x colours, The second parameter colurs are sub from the first parameter colours..
    //----------------------------------------------------------------------
    static  inline  unsigned Exe( unsigned c1, const unsigned c2, const unsigned)
    {
     6bc:	e7974106 	ldr	r4, [r7, r6, lsl #2]
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
     6c0:	e59fc0a8 	ldr	ip, [pc, #168]	; 770 <.text+0x770>
     6c4:	e7985106 	ldr	r5, [r8, r6, lsl #2]
     6c8:	e004e00c 	and	lr, r4, ip
      unsigned  t2_a = ((c2 & MASCARA_A_TWICE) >> BITS_BAJOS);                                                //  __R2__B2__g2
  
      unsigned  t1_b = ((c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS)) | MASCARA_SAT_B_TWICE;  //  _1G1_1r1_1b1
     6cc:	e59f10a0 	ldr	r1, [pc, #160]	; 774 <.text+0x774>
     6d0:	e59f00a0 	ldr	r0, [pc, #160]	; 778 <.text+0x778>
     6d4:	e59f2094 	ldr	r2, [pc, #148]	; 770 <.text+0x770>
     6d8:	e1a032ae 	mov	r3, lr, lsr #5
     6dc:	e59fc098 	ldr	ip, [pc, #152]	; 77c <.text+0x77c>
      unsigned  t2_b = ((c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS));                        //  __G2__r2__b2
     6e0:	e1a0e001 	mov	lr, r1
     6e4:	e1830000 	orr	r0, r3, r0
     6e8:	e0041001 	and	r1, r4, r1
     6ec:	e0052002 	and	r2, r5, r2
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
     6f0:	e59f3080 	ldr	r3, [pc, #128]	; 778 <.text+0x778>
     6f4:	e04002a2 	sub	r0, r0, r2, lsr #5
     6f8:	e181c00c 	orr	ip, r1, ip
     6fc:	e005e00e 	and	lr, r5, lr
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
     700:	e59f1074 	ldr	r1, [pc, #116]	; 77c <.text+0x77c>
     704:	e06ec00c 	rsb	ip, lr, ip
     708:	e0003003 	and	r3, r0, r3
     70c:	e00c2001 	and	r2, ip, r1
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
     710:	e04332a3 	sub	r3, r3, r3, lsr #5
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
     714:	e04212a2 	sub	r1, r2, r2, lsr #5
  
      t1_a &= t2_a;                                                             //  __RUxxBUxxgU  * U means Underflow
     718:	e0000003 	and	r0, r0, r3
      t1_b &= t2_b;                                                             //  __GUxxrSxxbU  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                           //  11xx11xx11xx  * Moves all to its correct place.
                                                                                //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);     //  11xx11xx11xx  * Moves all to its correct place.
     71c:	e59f2050 	ldr	r2, [pc, #80]	; 774 <.text+0x774>
     720:	e59f3048 	ldr	r3, [pc, #72]	; 770 <.text+0x770>
     724:	e00cc001 	and	ip, ip, r1
     728:	e1a00280 	mov	r0, r0, lsl #5
     72c:	e0001003 	and	r1, r0, r3
     730:	e00c0002 	and	r0, ip, r2
     734:	e181c000 	orr	ip, r1, r0
     738:	e787c106 	str	ip, [r7, r6, lsl #2]
     73c:	e2966001 	adds	r6, r6, #1	; 0x1
     740:	1a0001ad 	bne	dfc <_Z14uS_DrawSpriteTPtssS_ttt+0x94>
     744:	e51bc03c 	ldr	ip, [fp, #-60]
     748:	e51b0040 	ldr	r0, [fp, #-64]
     74c:	e2493001 	sub	r3, r9, #1	; 0x1
     750:	e3730001 	cmn	r3, #1	; 0x1
     754:	e0877100 	add	r7, r7, r0, lsl #2
     758:	e088810c 	add	r8, r8, ip, lsl #2
     75c:	e1a09003 	mov	r9, r3
     760:	1a0001ab 	bne	e14 <_Z14uS_DrawSpriteTPtssS_ttt+0xac>
     764:	e50b3038 	str	r3, [fp, #-56]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_Sub>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, 0, 0);
}
     768:	e24bd028 	sub	sp, fp, #40	; 0x28
     76c:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
     770:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
     774:	07c0f83e 	undefined
     778:	08020040 	stmeqda	r2, {r6}
     77c:	08010040 	stmeqda	r1, {r6}

00000780 <_Z14uS_DrawSpriteSPtssS_tt>:
     780:	e1a0c00d 	mov	ip, sp
     784:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
     788:	e24cb004 	sub	fp, ip, #4	; 0x4
     78c:	e24dd028 	sub	sp, sp, #40	; 0x28
     790:	e1db40b8 	ldrh	r4, [fp, #8]
     794:	e1dbe0b4 	ldrh	lr, [fp, #4]
     798:	e1a0c802 	mov	ip, r2, lsl #16
     79c:	e1a01801 	mov	r1, r1, lsl #16
     7a0:	e50b4038 	str	r4, [fp, #-56]
     7a4:	e24b4034 	sub	r4, fp, #52	; 0x34
     7a8:	e50b002c 	str	r0, [fp, #-44]
     7ac:	e50b3030 	str	r3, [fp, #-48]
     7b0:	e1a02841 	mov	r2, r1, asr #16
     7b4:	e1a0384c 	mov	r3, ip, asr #16
     7b8:	e50be034 	str	lr, [fp, #-52]
     7bc:	e58d4000 	str	r4, [sp]
     7c0:	e24be038 	sub	lr, fp, #56	; 0x38
     7c4:	e24bc03c 	sub	ip, fp, #60	; 0x3c
     7c8:	e24b002c 	sub	r0, fp, #44	; 0x2c
     7cc:	e24b1030 	sub	r1, fp, #48	; 0x30
     7d0:	e24b4040 	sub	r4, fp, #64	; 0x40
     7d4:	e58de004 	str	lr, [sp, #4]
     7d8:	e58dc008 	str	ip, [sp, #8]
     7dc:	e58d400c 	str	r4, [sp, #12]
     7e0:	ebfffffe 	bl	7e0 <_Z14uS_DrawSpriteSPtssS_tt+0x60>
     7e4:	e51be034 	ldr	lr, [fp, #-52]
     7e8:	e35e0000 	cmp	lr, #0	; 0x0
     7ec:	da00023d 	ble	10e8 <_Z16uS_DrawSpriteHTAPtssS_t+0x21c>
     7f0:	e51b3038 	ldr	r3, [fp, #-56]
     7f4:	e3530000 	cmp	r3, #0	; 0x0
     7f8:	da00023d 	ble	10f4 <_Z16uS_DrawSpriteHTAPtssS_t+0x228>
     7fc:	e51b003c 	ldr	r0, [fp, #-60]
     800:	e51b9040 	ldr	r9, [fp, #-64]
     804:	e2434001 	sub	r4, r3, #1	; 0x1
     808:	e1a070ce 	mov	r7, lr, asr #1
     80c:	e51b8030 	ldr	r8, [fp, #-48]
     810:	e51b302c 	ldr	r3, [fp, #-44]
     814:	e1a0c0a0 	mov	ip, r0, lsr #1
     818:	e267a000 	rsb	sl, r7, #0	; 0x0
     81c:	e1a000a9 	mov	r0, r9, lsr #1
     820:	e1a0208e 	mov	r2, lr, lsl #1
     824:	e3740001 	cmn	r4, #1	; 0x1
     828:	e0827008 	add	r7, r2, r8
     82c:	e50bc03c 	str	ip, [fp, #-60]
     830:	e50b0040 	str	r0, [fp, #-64]
     834:	e0828003 	add	r8, r2, r3
     838:	e50ba034 	str	sl, [fp, #-52]
     83c:	e1a09004 	mov	r9, r4
     840:	050b4038 	streq	r4, [fp, #-56]
     844:	0a00023d 	beq	1140 <_Z15uS_DrawSpriteTAPtssS_ttt+0x34>
     848:	e25a6000 	subs	r6, sl, #0	; 0x0
     84c:	0a000236 	beq	112c <_Z15uS_DrawSpriteTAPtssS_ttt+0x20>
    //  Returns:        The two added colours.
    //  Parameters:     Four 555x colours, The second parameter colurs are sub from the first parameter colours..
    //----------------------------------------------------------------------
    static  inline  unsigned Exe( unsigned c1, const unsigned c2, const unsigned)
    {
     850:	e7974106 	ldr	r4, [r7, r6, lsl #2]
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
     854:	e59fc0a8 	ldr	ip, [pc, #168]	; 904 <.text+0x904>
     858:	e7985106 	ldr	r5, [r8, r6, lsl #2]
     85c:	e004e00c 	and	lr, r4, ip
      unsigned  t2_a = ((c2 & MASCARA_A_TWICE) >> BITS_BAJOS);                                                //  __R2__B2__g2
  
      unsigned  t1_b = ((c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS)) | MASCARA_SAT_B_TWICE;  //  _1G1_1r1_1b1
     860:	e59f10a0 	ldr	r1, [pc, #160]	; 908 <.text+0x908>
     864:	e59f00a0 	ldr	r0, [pc, #160]	; 90c <.text+0x90c>
     868:	e59f2094 	ldr	r2, [pc, #148]	; 904 <.text+0x904>
     86c:	e1a032ae 	mov	r3, lr, lsr #5
     870:	e59fc098 	ldr	ip, [pc, #152]	; 910 <.text+0x910>
      unsigned  t2_b = ((c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS));                        //  __G2__r2__b2
     874:	e1a0e001 	mov	lr, r1
     878:	e1830000 	orr	r0, r3, r0
     87c:	e0041001 	and	r1, r4, r1
     880:	e0052002 	and	r2, r5, r2
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
     884:	e59f3080 	ldr	r3, [pc, #128]	; 90c <.text+0x90c>
     888:	e04002a2 	sub	r0, r0, r2, lsr #5
     88c:	e181c00c 	orr	ip, r1, ip
     890:	e005e00e 	and	lr, r5, lr
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
     894:	e59f1074 	ldr	r1, [pc, #116]	; 910 <.text+0x910>
     898:	e06ec00c 	rsb	ip, lr, ip
     89c:	e0003003 	and	r3, r0, r3
     8a0:	e00c2001 	and	r2, ip, r1
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
     8a4:	e04332a3 	sub	r3, r3, r3, lsr #5
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
     8a8:	e04212a2 	sub	r1, r2, r2, lsr #5
  
      t1_a &= t2_a;                                                             //  __RUxxBUxxgU  * U means Underflow
     8ac:	e0000003 	and	r0, r0, r3
      t1_b &= t2_b;                                                             //  __GUxxrSxxbU  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                           //  11xx11xx11xx  * Moves all to its correct place.
                                                                                //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);     //  11xx11xx11xx  * Moves all to its correct place.
     8b0:	e59f2050 	ldr	r2, [pc, #80]	; 908 <.text+0x908>
     8b4:	e59f3048 	ldr	r3, [pc, #72]	; 904 <.text+0x904>
     8b8:	e00cc001 	and	ip, ip, r1
     8bc:	e1a00280 	mov	r0, r0, lsl #5
     8c0:	e0001003 	and	r1, r0, r3
     8c4:	e00c2002 	and	r2, ip, r2
     8c8:	e181c002 	orr	ip, r1, r2
     8cc:	e787c106 	str	ip, [r7, r6, lsl #2]
     8d0:	e2966001 	adds	r6, r6, #1	; 0x1
     8d4:	1a000212 	bne	1124 <_Z15uS_DrawSpriteTAPtssS_ttt+0x18>
     8d8:	e51bc03c 	ldr	ip, [fp, #-60]
     8dc:	e51b0040 	ldr	r0, [fp, #-64]
     8e0:	e2493001 	sub	r3, r9, #1	; 0x1
     8e4:	e3730001 	cmn	r3, #1	; 0x1
     8e8:	e0877100 	add	r7, r7, r0, lsl #2
     8ec:	e088810c 	add	r8, r8, ip, lsl #2
     8f0:	e1a09003 	mov	r9, r3
     8f4:	1a000210 	bne	113c <_Z15uS_DrawSpriteTAPtssS_ttt+0x30>
     8f8:	e50b3038 	str	r3, [fp, #-56]
     8fc:	e24bd028 	sub	sp, fp, #40	; 0x28
     900:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
     904:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
     908:	07c0f83e 	undefined
     90c:	08020040 	stmeqda	r2, {r6}
     910:	08010040 	stmeqda	r1, {r6}

00000914 <_Z15uS_DrawSpriteHBPtssS_h>:

void uS_DrawSpriteHB ( u16 *sprite, short put_x, short put_y, u16 *framebuffer,u8 alpha)
{
     914:	e1a0c00d 	mov	ip, sp
     918:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
     91c:	e24cb004 	sub	fp, ip, #4	; 0x4
     920:	e24dd028 	sub	sp, sp, #40	; 0x28
     924:	e1a0e000 	mov	lr, r0
     928:	e1de70b4 	ldrh	r7, [lr, #4]
     92c:	e1de40b6 	ldrh	r4, [lr, #6]
     930:	e1a00802 	mov	r0, r2, lsl #16
     934:	e28ec00c 	add	ip, lr, #12	; 0xc
     938:	e1a01801 	mov	r1, r1, lsl #16
     93c:	e24be034 	sub	lr, fp, #52	; 0x34
     940:	e50b3030 	str	r3, [fp, #-48]
     944:	e1a02841 	mov	r2, r1, asr #16
     948:	e1a03840 	mov	r3, r0, asr #16
     94c:	e50bc02c 	str	ip, [fp, #-44]
     950:	e50b7034 	str	r7, [fp, #-52]
     954:	e58de000 	str	lr, [sp]
     958:	e24b7038 	sub	r7, fp, #56	; 0x38
     95c:	e24be040 	sub	lr, fp, #64	; 0x40
     960:	e24bc03c 	sub	ip, fp, #60	; 0x3c
     964:	e24b002c 	sub	r0, fp, #44	; 0x2c
     968:	e24b1030 	sub	r1, fp, #48	; 0x30
     96c:	e58d7004 	str	r7, [sp, #4]
     970:	e58de00c 	str	lr, [sp, #12]
     974:	e50b4038 	str	r4, [fp, #-56]
     978:	e58dc008 	str	ip, [sp, #8]
     97c:	e5db7004 	ldrb	r7, [fp, #4]
     980:	ebfffffe 	bl	980 <_Z15uS_DrawSpriteHBPtssS_h+0x6c>
     984:	e51be034 	ldr	lr, [fp, #-52]
     988:	e35e0000 	cmp	lr, #0	; 0x0
     98c:	da00029d 	ble	1408 <_Z16uS_DrawSpriteHTSPtssS_t+0xc4>
     990:	e51b3038 	ldr	r3, [fp, #-56]
     994:	e3530000 	cmp	r3, #0	; 0x0
     998:	da00029d 	ble	1414 <_Z16uS_DrawSpriteHTSPtssS_t+0xd0>
     99c:	e51ba03c 	ldr	sl, [fp, #-60]
     9a0:	e51b9040 	ldr	r9, [fp, #-64]
     9a4:	e2434001 	sub	r4, r3, #1	; 0x1
     9a8:	e1a050ce 	mov	r5, lr, asr #1
     9ac:	e51b6030 	ldr	r6, [fp, #-48]
     9b0:	e51b302c 	ldr	r3, [fp, #-44]
     9b4:	e1a0c0aa 	mov	ip, sl, lsr #1
     9b8:	e1a000a9 	mov	r0, r9, lsr #1
     9bc:	e265a000 	rsb	sl, r5, #0	; 0x0
     9c0:	e1a0208e 	mov	r2, lr, lsl #1
     9c4:	e3740001 	cmn	r4, #1	; 0x1
     9c8:	e0825006 	add	r5, r2, r6
     9cc:	e50bc03c 	str	ip, [fp, #-60]
     9d0:	e50b0040 	str	r0, [fp, #-64]
     9d4:	e0826003 	add	r6, r2, r3
     9d8:	e50ba034 	str	sl, [fp, #-52]
     9dc:	e1a09004 	mov	r9, r4
     9e0:	050b4038 	streq	r4, [fp, #-56]
     9e4:	0a00029d 	beq	1460 <_Z16uS_DrawSpriteHTSPtssS_t+0x11c>
     9e8:	e2678020 	rsb	r8, r7, #32	; 0x20
     9ec:	e25a4000 	subs	r4, sl, #0	; 0x0
     9f0:	0a000296 	beq	1450 <_Z16uS_DrawSpriteHTSPtssS_t+0x10c>
    //  Parameters:     iAlfa=0 Only c1 is set, iAlfa=32 only c2 is set
    //		    c1; two 555x Colours thar will blend with c2 that contains anothe two 555x colours.
    //----------------------------------------------------------------------
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned uAlpha)
    {
     9f4:	e7961104 	ldr	r1, [r6, r4, lsl #2]
      unsigned  ta = (c1 & MASCARA_A_TWICE)>>BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  tb = (c1 & MASCARA_B_TWICE);                                      //  __G1__r1__b1
    
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
     9f8:	e59f2084 	ldr	r2, [pc, #132]	; a84 <.text+0xa84>
      tb += uAlpha * (c2 & MASCARA_B_TWICE);                                       //  __G2__r2__b2
     9fc:	e59f0084 	ldr	r0, [pc, #132]	; a88 <.text+0xa88>
     a00:	e001c002 	and	ip, r1, r2
     a04:	e001e000 	and	lr, r1, r0
     a08:	e1a032ac 	mov	r3, ip, lsr #5
     a0c:	e00c0e97 	mul	ip, r7, lr
     a10:	e7950104 	ldr	r0, [r5, r4, lsl #2]
     a14:	e00e0397 	mul	lr, r7, r3
     a18:	e59f1068 	ldr	r1, [pc, #104]	; a88 <.text+0xa88>
     a1c:	e59f2060 	ldr	r2, [pc, #96]	; a84 <.text+0xa84>
     a20:	e0003001 	and	r3, r0, r1
     a24:	e0002002 	and	r2, r0, r2
     a28:	e021c398 	mla	r1, r8, r3, ip
     a2c:	e1a032a2 	mov	r3, r2, lsr #5
     a30:	e020e398 	mla	r0, r8, r3, lr
    
      ta &=                    MASCARA_A_TWICE;                                   //  R2__B2__g2__
     a34:	e59fc048 	ldr	ip, [pc, #72]	; a84 <.text+0xa84>
      ta += (tb>>BITS_BAJOS) & MASCARA_B_TWICE;                                   //  __G2__r2__b2
     a38:	e59f2048 	ldr	r2, [pc, #72]	; a88 <.text+0xa88>
     a3c:	e1a012a1 	mov	r1, r1, lsr #5
     a40:	e000300c 	and	r3, r0, ip
     a44:	e0010002 	and	r0, r1, r2
     a48:	e083c000 	add	ip, r3, r0
     a4c:	e785c104 	str	ip, [r5, r4, lsl #2]
     a50:	e2944001 	adds	r4, r4, #1	; 0x1
     a54:	1a00027b 	bne	1448 <_Z16uS_DrawSpriteHTSPtssS_t+0x104>
     a58:	e51bc03c 	ldr	ip, [fp, #-60]
     a5c:	e51b0040 	ldr	r0, [fp, #-64]
     a60:	e2493001 	sub	r3, r9, #1	; 0x1
     a64:	e3730001 	cmn	r3, #1	; 0x1
     a68:	e0855100 	add	r5, r5, r0, lsl #2
     a6c:	e086610c 	add	r6, r6, ip, lsl #2
     a70:	e1a09003 	mov	r9, r3
     a74:	1a000279 	bne	1460 <_Z16uS_DrawSpriteHTSPtssS_t+0x11c>
     a78:	e50b3038 	str	r3, [fp, #-56]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_Blend>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, 0, alpha);
}
     a7c:	e24bd028 	sub	sp, fp, #40	; 0x28
     a80:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
     a84:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
     a88:	07c0f83e 	undefined

00000a8c <_Z14uS_DrawSpriteBPtssS_tth>:
     a8c:	e1a0c00d 	mov	ip, sp
     a90:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
     a94:	e24cb004 	sub	fp, ip, #4	; 0x4
     a98:	e24dd028 	sub	sp, sp, #40	; 0x28
     a9c:	e1db70b4 	ldrh	r7, [fp, #4]
     aa0:	e1a0c802 	mov	ip, r2, lsl #16
     aa4:	e1a01801 	mov	r1, r1, lsl #16
     aa8:	e1db40b8 	ldrh	r4, [fp, #8]
     aac:	e24be034 	sub	lr, fp, #52	; 0x34
     ab0:	e50b002c 	str	r0, [fp, #-44]
     ab4:	e50b3030 	str	r3, [fp, #-48]
     ab8:	e1a02841 	mov	r2, r1, asr #16
     abc:	e1a0384c 	mov	r3, ip, asr #16
     ac0:	e50b7034 	str	r7, [fp, #-52]
     ac4:	e58de000 	str	lr, [sp]
     ac8:	e24b7038 	sub	r7, fp, #56	; 0x38
     acc:	e24be040 	sub	lr, fp, #64	; 0x40
     ad0:	e24bc03c 	sub	ip, fp, #60	; 0x3c
     ad4:	e24b002c 	sub	r0, fp, #44	; 0x2c
     ad8:	e24b1030 	sub	r1, fp, #48	; 0x30
     adc:	e58d7004 	str	r7, [sp, #4]
     ae0:	e58de00c 	str	lr, [sp, #12]
     ae4:	e50b4038 	str	r4, [fp, #-56]
     ae8:	e58dc008 	str	ip, [sp, #8]
     aec:	e5db700c 	ldrb	r7, [fp, #12]
     af0:	ebfffffe 	bl	af0 <_Z14uS_DrawSpriteBPtssS_tth+0x64>
     af4:	e51be034 	ldr	lr, [fp, #-52]
     af8:	e35e0000 	cmp	lr, #0	; 0x0
     afc:	da0002f9 	ble	16e8 <_Z15uS_DrawSpriteTSPtssS_ttt+0x148>
     b00:	e51b3038 	ldr	r3, [fp, #-56]
     b04:	e3530000 	cmp	r3, #0	; 0x0
     b08:	da0002f9 	ble	16f4 <_Z15uS_DrawSpriteTSPtssS_ttt+0x154>
     b0c:	e51b003c 	ldr	r0, [fp, #-60]
     b10:	e51b9040 	ldr	r9, [fp, #-64]
     b14:	e2434001 	sub	r4, r3, #1	; 0x1
     b18:	e1a050ce 	mov	r5, lr, asr #1
     b1c:	e51b6030 	ldr	r6, [fp, #-48]
     b20:	e51b302c 	ldr	r3, [fp, #-44]
     b24:	e1a0c0a0 	mov	ip, r0, lsr #1
     b28:	e265a000 	rsb	sl, r5, #0	; 0x0
     b2c:	e1a000a9 	mov	r0, r9, lsr #1
     b30:	e1a0208e 	mov	r2, lr, lsl #1
     b34:	e3740001 	cmn	r4, #1	; 0x1
     b38:	e0825006 	add	r5, r2, r6
     b3c:	e50bc03c 	str	ip, [fp, #-60]
     b40:	e50b0040 	str	r0, [fp, #-64]
     b44:	e0826003 	add	r6, r2, r3
     b48:	e50ba034 	str	sl, [fp, #-52]
     b4c:	e1a09004 	mov	r9, r4
     b50:	050b4038 	streq	r4, [fp, #-56]
     b54:	0a0002f9 	beq	1740 <_Z15uS_DrawSpriteTSPtssS_ttt+0x1a0>
     b58:	e2678020 	rsb	r8, r7, #32	; 0x20
     b5c:	e25a4000 	subs	r4, sl, #0	; 0x0
     b60:	0a0002f2 	beq	1730 <_Z15uS_DrawSpriteTSPtssS_ttt+0x190>
    //  Parameters:     iAlfa=0 Only c1 is set, iAlfa=32 only c2 is set
    //		    c1; two 555x Colours thar will blend with c2 that contains anothe two 555x colours.
    //----------------------------------------------------------------------
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned uAlpha)
    {
     b64:	e7961104 	ldr	r1, [r6, r4, lsl #2]
      unsigned  ta = (c1 & MASCARA_A_TWICE)>>BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  tb = (c1 & MASCARA_B_TWICE);                                      //  __G1__r1__b1
    
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
     b68:	e59f2084 	ldr	r2, [pc, #132]	; bf4 <.text+0xbf4>
      tb += uAlpha * (c2 & MASCARA_B_TWICE);                                       //  __G2__r2__b2
     b6c:	e59f0084 	ldr	r0, [pc, #132]	; bf8 <.text+0xbf8>
     b70:	e001c002 	and	ip, r1, r2
     b74:	e001e000 	and	lr, r1, r0
     b78:	e1a032ac 	mov	r3, ip, lsr #5
     b7c:	e00c0e97 	mul	ip, r7, lr
     b80:	e7950104 	ldr	r0, [r5, r4, lsl #2]
     b84:	e00e0397 	mul	lr, r7, r3
     b88:	e59f1068 	ldr	r1, [pc, #104]	; bf8 <.text+0xbf8>
     b8c:	e59f2060 	ldr	r2, [pc, #96]	; bf4 <.text+0xbf4>
     b90:	e0003001 	and	r3, r0, r1
     b94:	e0002002 	and	r2, r0, r2
     b98:	e021c398 	mla	r1, r8, r3, ip
     b9c:	e1a022a2 	mov	r2, r2, lsr #5
     ba0:	e020e298 	mla	r0, r8, r2, lr
    
      ta &=                    MASCARA_A_TWICE;                                   //  R2__B2__g2__
      ta += (tb>>BITS_BAJOS) & MASCARA_B_TWICE;                                   //  __G2__r2__b2
     ba4:	e59fc04c 	ldr	ip, [pc, #76]	; bf8 <.text+0xbf8>
     ba8:	e59f3044 	ldr	r3, [pc, #68]	; bf4 <.text+0xbf4>
     bac:	e1a012a1 	mov	r1, r1, lsr #5
     bb0:	e0003003 	and	r3, r0, r3
     bb4:	e001200c 	and	r2, r1, ip
     bb8:	e083c002 	add	ip, r3, r2
     bbc:	e785c104 	str	ip, [r5, r4, lsl #2]
     bc0:	e2944001 	adds	r4, r4, #1	; 0x1
     bc4:	1a0002d7 	bne	1728 <_Z15uS_DrawSpriteTSPtssS_ttt+0x188>
     bc8:	e51bc03c 	ldr	ip, [fp, #-60]
     bcc:	e51b0040 	ldr	r0, [fp, #-64]
     bd0:	e2493001 	sub	r3, r9, #1	; 0x1
     bd4:	e3730001 	cmn	r3, #1	; 0x1
     bd8:	e0855100 	add	r5, r5, r0, lsl #2
     bdc:	e086610c 	add	r6, r6, ip, lsl #2
     be0:	e1a09003 	mov	r9, r3
     be4:	1a0002d5 	bne	1740 <_Z15uS_DrawSpriteTSPtssS_ttt+0x1a0>
     be8:	e50b3038 	str	r3, [fp, #-56]
     bec:	e24bd028 	sub	sp, fp, #40	; 0x28
     bf0:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
     bf4:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
     bf8:	07c0f83e 	undefined

00000bfc <_Z15uS_DrawSpriteHTPtssS_t>:

void uS_DrawSpriteHT  ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans)
{
     bfc:	e1a0c00d 	mov	ip, sp
     c00:	e92dddf0 	stmdb	sp!, {r4, r5, r6, r7, r8, sl, fp, ip, lr, pc}
     c04:	e24cb004 	sub	fp, ip, #4	; 0x4
     c08:	e24dd028 	sub	sp, sp, #40	; 0x28
     c0c:	e1a0e000 	mov	lr, r0
     c10:	e1de60b4 	ldrh	r6, [lr, #4]
     c14:	e1de40b6 	ldrh	r4, [lr, #6]
     c18:	e1a00802 	mov	r0, r2, lsl #16
     c1c:	e28ec00c 	add	ip, lr, #12	; 0xc
     c20:	e1a01801 	mov	r1, r1, lsl #16
     c24:	e24be030 	sub	lr, fp, #48	; 0x30
     c28:	e50b302c 	str	r3, [fp, #-44]
     c2c:	e1a02841 	mov	r2, r1, asr #16
     c30:	e1a03840 	mov	r3, r0, asr #16
     c34:	e50bc028 	str	ip, [fp, #-40]
     c38:	e24b0028 	sub	r0, fp, #40	; 0x28
     c3c:	e50b6030 	str	r6, [fp, #-48]
     c40:	e58de000 	str	lr, [sp]
     c44:	e24b6034 	sub	r6, fp, #52	; 0x34
     c48:	e24bc038 	sub	ip, fp, #56	; 0x38
     c4c:	e24be03c 	sub	lr, fp, #60	; 0x3c
     c50:	e24b102c 	sub	r1, fp, #44	; 0x2c
     c54:	e58d6004 	str	r6, [sp, #4]
     c58:	e50b4034 	str	r4, [fp, #-52]
     c5c:	e58dc008 	str	ip, [sp, #8]
     c60:	e58de00c 	str	lr, [sp, #12]
     c64:	e1db60b4 	ldrh	r6, [fp, #4]
     c68:	ebfffffe 	bl	c68 <_Z15uS_DrawSpriteHTPtssS_t+0x6c>
     c6c:	e51b0030 	ldr	r0, [fp, #-48]
     c70:	e3500000 	cmp	r0, #0	; 0x0
     c74:	da000356 	ble	19d4 <_Z16uS_DrawSpriteHTBPtssS_th+0x1e0>
     c78:	e51b3034 	ldr	r3, [fp, #-52]
     c7c:	e3530000 	cmp	r3, #0	; 0x0
     c80:	da000356 	ble	19e0 <_Z16uS_DrawSpriteHTBPtssS_th+0x1ec>
     c84:	e51ba038 	ldr	sl, [fp, #-56]
     c88:	e51b803c 	ldr	r8, [fp, #-60]
     c8c:	e2434001 	sub	r4, r3, #1	; 0x1
     c90:	e1a070c0 	mov	r7, r0, asr #1
     c94:	e51b502c 	ldr	r5, [fp, #-44]
     c98:	e51b3028 	ldr	r3, [fp, #-40]
     c9c:	e1a0e0aa 	mov	lr, sl, lsr #1
     ca0:	e1a0c0a8 	mov	ip, r8, lsr #1
     ca4:	e1a02080 	mov	r2, r0, lsl #1
     ca8:	e2678000 	rsb	r8, r7, #0	; 0x0
     cac:	e3740001 	cmn	r4, #1	; 0x1
     cb0:	e0821005 	add	r1, r2, r5
     cb4:	e50be038 	str	lr, [fp, #-56]
     cb8:	e50bc03c 	str	ip, [fp, #-60]
     cbc:	e0825003 	add	r5, r2, r3
     cc0:	e50b8030 	str	r8, [fp, #-48]
     cc4:	e1867806 	orr	r7, r6, r6, lsl #16
     cc8:	e1a0a004 	mov	sl, r4
     ccc:	050b4034 	streq	r4, [fp, #-52]
     cd0:	0a000356 	beq	1a30 <_Z15uS_DrawSpriteTBPtssS_ttth+0x10>
     cd4:	e1a00807 	mov	r0, r7, lsl #16
     cd8:	e1a06820 	mov	r6, r0, lsr #16
     cdc:	e2580000 	subs	r0, r8, #0	; 0x0
     ce0:	0a00034f 	beq	1a24 <_Z15uS_DrawSpriteTBPtssS_ttth+0x4>
     ce4:	e795c100 	ldr	ip, [r5, r0, lsl #2]
     ce8:	e15c0007 	cmp	ip, r7
     cec:	e1a0300c 	mov	r3, ip
     cf0:	e1a0280c 	mov	r2, ip, lsl #16
     cf4:	0a00034b 	beq	1a28 <_Z15uS_DrawSpriteTBPtssS_ttth+0x8>
     cf8:	e1560822 	cmp	r6, r2, lsr #16
     cfc:	07913100 	ldreq	r3, [r1, r0, lsl #2]
     d00:	e1a0e82c 	mov	lr, ip, lsr #16
     d04:	01a03803 	moveq	r3, r3, lsl #16
     d08:	01a03823 	moveq	r3, r3, lsr #16
     d0c:	e1a0e80e 	mov	lr, lr, lsl #16
     d10:	018e3003 	orreq	r3, lr, r3
     d14:	e156082c 	cmp	r6, ip, lsr #16
     d18:	07913100 	ldreq	r3, [r1, r0, lsl #2]
     d1c:	e1a0480c 	mov	r4, ip, lsl #16
     d20:	01a03823 	moveq	r3, r3, lsr #16
     d24:	01a03803 	moveq	r3, r3, lsl #16
     d28:	e1a04824 	mov	r4, r4, lsr #16
     d2c:	01833004 	orreq	r3, r3, r4
  };
  struct  SetTwice
  {
    static  inline  unsigned Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
     d30:	e7813100 	str	r3, [r1, r0, lsl #2]
     d34:	e2900001 	adds	r0, r0, #1	; 0x1
     d38:	1a000337 	bne	1a1c <.text+0x1a1c>
     d3c:	e51be038 	ldr	lr, [fp, #-56]
     d40:	e51bc03c 	ldr	ip, [fp, #-60]
     d44:	e24a3001 	sub	r3, sl, #1	; 0x1
     d48:	e3730001 	cmn	r3, #1	; 0x1
     d4c:	e081110c 	add	r1, r1, ip, lsl #2
     d50:	e085510e 	add	r5, r5, lr, lsl #2
     d54:	e1a0a003 	mov	sl, r3
     d58:	1a000335 	bne	1a34 <_Z15uS_DrawSpriteTBPtssS_ttth+0x14>
     d5c:	e50b3034 	str	r3, [fp, #-52]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_SetT>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, trans, 0);
}
     d60:	e24bd024 	sub	sp, fp, #36	; 0x24
     d64:	e89dadf0 	ldmia	sp, {r4, r5, r6, r7, r8, sl, fp, sp, pc}

00000d68 <_Z14uS_DrawSpriteTPtssS_ttt>:
     d68:	e1a0c00d 	mov	ip, sp
     d6c:	e92dddf0 	stmdb	sp!, {r4, r5, r6, r7, r8, sl, fp, ip, lr, pc}
     d70:	e24cb004 	sub	fp, ip, #4	; 0x4
     d74:	e24dd028 	sub	sp, sp, #40	; 0x28
     d78:	e1db60b8 	ldrh	r6, [fp, #8]
     d7c:	e1a0c802 	mov	ip, r2, lsl #16
     d80:	e1a01801 	mov	r1, r1, lsl #16
     d84:	e1db40bc 	ldrh	r4, [fp, #12]
     d88:	e24be030 	sub	lr, fp, #48	; 0x30
     d8c:	e50b0028 	str	r0, [fp, #-40]
     d90:	e50b302c 	str	r3, [fp, #-44]
     d94:	e1a02841 	mov	r2, r1, asr #16
     d98:	e1a0384c 	mov	r3, ip, asr #16
     d9c:	e24b0028 	sub	r0, fp, #40	; 0x28
     da0:	e50b6030 	str	r6, [fp, #-48]
     da4:	e58de000 	str	lr, [sp]
     da8:	e24b6034 	sub	r6, fp, #52	; 0x34
     dac:	e24bc038 	sub	ip, fp, #56	; 0x38
     db0:	e24be03c 	sub	lr, fp, #60	; 0x3c
     db4:	e24b102c 	sub	r1, fp, #44	; 0x2c
     db8:	e58d6004 	str	r6, [sp, #4]
     dbc:	e50b4034 	str	r4, [fp, #-52]
     dc0:	e58dc008 	str	ip, [sp, #8]
     dc4:	e58de00c 	str	lr, [sp, #12]
     dc8:	e1db60b4 	ldrh	r6, [fp, #4]
     dcc:	ebfffffe 	bl	dcc <_Z14uS_DrawSpriteTPtssS_ttt+0x64>
     dd0:	e51b0030 	ldr	r0, [fp, #-48]
     dd4:	e3500000 	cmp	r0, #0	; 0x0
     dd8:	da0003af 	ble	1c9c <.text+0x1c9c>
     ddc:	e51b3034 	ldr	r3, [fp, #-52]
     de0:	e3530000 	cmp	r3, #0	; 0x0
     de4:	da0003af 	ble	1ca8 <.text+0x1ca8>
     de8:	e51b8038 	ldr	r8, [fp, #-56]
     dec:	e51b703c 	ldr	r7, [fp, #-60]
     df0:	e2434001 	sub	r4, r3, #1	; 0x1
     df4:	e1a050c0 	mov	r5, r0, asr #1
     df8:	e1a02080 	mov	r2, r0, lsl #1
     dfc:	e51b3028 	ldr	r3, [fp, #-40]
     e00:	e51b002c 	ldr	r0, [fp, #-44]
     e04:	e1a0e0a8 	mov	lr, r8, lsr #1
     e08:	e1a0c0a7 	mov	ip, r7, lsr #1
     e0c:	e2658000 	rsb	r8, r5, #0	; 0x0
     e10:	e3740001 	cmn	r4, #1	; 0x1
     e14:	e0821000 	add	r1, r2, r0
     e18:	e50be038 	str	lr, [fp, #-56]
     e1c:	e50bc03c 	str	ip, [fp, #-60]
     e20:	e0825003 	add	r5, r2, r3
     e24:	e50b8030 	str	r8, [fp, #-48]
     e28:	e1867806 	orr	r7, r6, r6, lsl #16
     e2c:	e1a0a004 	mov	sl, r4
     e30:	050b4034 	streq	r4, [fp, #-52]
     e34:	0a0003af 	beq	1cf8 <.text+0x1cf8>
     e38:	e1a03807 	mov	r3, r7, lsl #16
     e3c:	e1a06823 	mov	r6, r3, lsr #16
     e40:	e2580000 	subs	r0, r8, #0	; 0x0
     e44:	0a0003a8 	beq	1cec <.text+0x1cec>
     e48:	e795c100 	ldr	ip, [r5, r0, lsl #2]
     e4c:	e15c0007 	cmp	ip, r7
     e50:	e1a0300c 	mov	r3, ip
     e54:	e1a0280c 	mov	r2, ip, lsl #16
     e58:	0a0003a4 	beq	1cf0 <.text+0x1cf0>
     e5c:	e1560822 	cmp	r6, r2, lsr #16
     e60:	07913100 	ldreq	r3, [r1, r0, lsl #2]
     e64:	e1a0e82c 	mov	lr, ip, lsr #16
     e68:	01a03803 	moveq	r3, r3, lsl #16
     e6c:	01a03823 	moveq	r3, r3, lsr #16
     e70:	e1a0e80e 	mov	lr, lr, lsl #16
     e74:	018e3003 	orreq	r3, lr, r3
     e78:	e156082c 	cmp	r6, ip, lsr #16
     e7c:	07913100 	ldreq	r3, [r1, r0, lsl #2]
     e80:	e1a0480c 	mov	r4, ip, lsl #16
     e84:	01a03823 	moveq	r3, r3, lsr #16
     e88:	01a03803 	moveq	r3, r3, lsl #16
     e8c:	e1a04824 	mov	r4, r4, lsr #16
     e90:	01833004 	orreq	r3, r3, r4
  };
  struct  SetTwice
  {
    static  inline  unsigned Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
     e94:	e7813100 	str	r3, [r1, r0, lsl #2]
     e98:	e2900001 	adds	r0, r0, #1	; 0x1
     e9c:	1a000390 	bne	1ce4 <.text+0x1ce4>
     ea0:	e51be038 	ldr	lr, [fp, #-56]
     ea4:	e51bc03c 	ldr	ip, [fp, #-60]
     ea8:	e24a3001 	sub	r3, sl, #1	; 0x1
     eac:	e3730001 	cmn	r3, #1	; 0x1
     eb0:	e081110c 	add	r1, r1, ip, lsl #2
     eb4:	e085510e 	add	r5, r5, lr, lsl #2
     eb8:	e1a0a003 	mov	sl, r3
     ebc:	1a00038e 	bne	1cfc <.text+0x1cfc>
     ec0:	e50b3034 	str	r3, [fp, #-52]
     ec4:	e24bd024 	sub	sp, fp, #36	; 0x24
     ec8:	e89dadf0 	ldmia	sp, {r4, r5, r6, r7, r8, sl, fp, sp, pc}

00000ecc <_Z16uS_DrawSpriteHTAPtssS_t>:

void uS_DrawSpriteHTA ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans)
{
     ecc:	e1a0c00d 	mov	ip, sp
     ed0:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
     ed4:	e24cb004 	sub	fp, ip, #4	; 0x4
     ed8:	e24dd04c 	sub	sp, sp, #76	; 0x4c
     edc:	e1a0e000 	mov	lr, r0
     ee0:	e1de50b4 	ldrh	r5, [lr, #4]
     ee4:	e1de40b6 	ldrh	r4, [lr, #6]
     ee8:	e1a00802 	mov	r0, r2, lsl #16
     eec:	e28ec00c 	add	ip, lr, #12	; 0xc
     ef0:	e1a01801 	mov	r1, r1, lsl #16
     ef4:	e24be034 	sub	lr, fp, #52	; 0x34
     ef8:	e50b3030 	str	r3, [fp, #-48]
     efc:	e1a02841 	mov	r2, r1, asr #16
     f00:	e1a03840 	mov	r3, r0, asr #16
     f04:	e50bc02c 	str	ip, [fp, #-44]
     f08:	e50b5034 	str	r5, [fp, #-52]
     f0c:	e58de000 	str	lr, [sp]
     f10:	e24b5038 	sub	r5, fp, #56	; 0x38
     f14:	e24be040 	sub	lr, fp, #64	; 0x40
     f18:	e24bc03c 	sub	ip, fp, #60	; 0x3c
     f1c:	e24b002c 	sub	r0, fp, #44	; 0x2c
     f20:	e24b1030 	sub	r1, fp, #48	; 0x30
     f24:	e58d5004 	str	r5, [sp, #4]
     f28:	e58de00c 	str	lr, [sp, #12]
     f2c:	e50b4038 	str	r4, [fp, #-56]
     f30:	e58dc008 	str	ip, [sp, #8]
     f34:	e1db50b4 	ldrh	r5, [fp, #4]
     f38:	ebfffffe 	bl	f38 <_Z16uS_DrawSpriteHTAPtssS_t+0x6c>
     f3c:	e51be034 	ldr	lr, [fp, #-52]
     f40:	e35e0000 	cmp	lr, #0	; 0x0
     f44:	da00043b 	ble	2038 <.text+0x2038>
     f48:	e51b3038 	ldr	r3, [fp, #-56]
     f4c:	e3530000 	cmp	r3, #0	; 0x0
     f50:	da00043b 	ble	2044 <.text+0x2044>
     f54:	e51b003c 	ldr	r0, [fp, #-60]
     f58:	e51b2040 	ldr	r2, [fp, #-64]
     f5c:	e2434001 	sub	r4, r3, #1	; 0x1
     f60:	e51b3030 	ldr	r3, [fp, #-48]
     f64:	e1a0c0a0 	mov	ip, r0, lsr #1
     f68:	e1a000a2 	mov	r0, r2, lsr #1
     f6c:	e1a0208e 	mov	r2, lr, lsl #1
     f70:	e0823003 	add	r3, r2, r3
     f74:	e50b304c 	str	r3, [fp, #-76]
     f78:	e51b302c 	ldr	r3, [fp, #-44]
     f7c:	e1a010ce 	mov	r1, lr, asr #1
     f80:	e2611000 	rsb	r1, r1, #0	; 0x0
     f84:	e3740001 	cmn	r4, #1	; 0x1
     f88:	e0822003 	add	r2, r2, r3
     f8c:	e1855805 	orr	r5, r5, r5, lsl #16
     f90:	e50b1050 	str	r1, [fp, #-80]
     f94:	e50bc03c 	str	ip, [fp, #-60]
     f98:	e50b0040 	str	r0, [fp, #-64]
     f9c:	e50b2048 	str	r2, [fp, #-72]
     fa0:	e50b1034 	str	r1, [fp, #-52]
     fa4:	e50b5044 	str	r5, [fp, #-68]
     fa8:	e50b4060 	str	r4, [fp, #-96]
     fac:	050b4038 	streq	r4, [fp, #-56]
     fb0:	0a00043b 	beq	20a4 <.text+0x20a4>
     fb4:	e1a03805 	mov	r3, r5, lsl #16
     fb8:	e1a05823 	mov	r5, r3, lsr #16
     fbc:	e50b5058 	str	r5, [fp, #-88]
     fc0:	e51b5050 	ldr	r5, [fp, #-80]
     fc4:	e3550000 	cmp	r5, #0	; 0x0
     fc8:	0a00042f 	beq	208c <.text+0x208c>
     fcc:	e51b2048 	ldr	r2, [fp, #-72]
     fd0:	e51bc044 	ldr	ip, [fp, #-68]
     fd4:	e7924105 	ldr	r4, [r2, r5, lsl #2]
     fd8:	e1a01105 	mov	r1, r5, lsl #2
     fdc:	e154000c 	cmp	r4, ip
     fe0:	e50b1054 	str	r1, [fp, #-84]
     fe4:	e1a03004 	mov	r3, r4
     fe8:	e1a01804 	mov	r1, r4, lsl #16
     fec:	0a00042b 	beq	20a0 <.text+0x20a0>
     ff0:	e51b6058 	ldr	r6, [fp, #-88]
     ff4:	e1a02824 	mov	r2, r4, lsr #16
     ff8:	e1560821 	cmp	r6, r1, lsr #16
     ffc:	e1a09802 	mov	r9, r2, lsl #16
    1000:	051b004c 	ldreq	r0, [fp, #-76]
    1004:	151b204c 	ldrne	r2, [fp, #-76]
    1008:	07901105 	ldreq	r1, [r0, r5, lsl #2]
    100c:	17921105 	ldrne	r1, [r2, r5, lsl #2]
    1010:	01a03801 	moveq	r3, r1, lsl #16
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
    1014:	e59fa0e0 	ldr	sl, [pc, #224]	; 10fc <.text+0x10fc>
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
    1018:	e59f70e0 	ldr	r7, [pc, #224]	; 1100 <.text+0x1100>
    101c:	e1a0c821 	mov	ip, r1, lsr #16
    1020:	01a03823 	moveq	r3, r3, lsr #16
    1024:	e50bc064 	str	ip, [fp, #-100]
    1028:	01893003 	orreq	r3, r9, r3
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
    102c:	e001800a 	and	r8, r1, sl
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
      unsigned  t2_b = (c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G2__r2__b2
    1030:	e1a00007 	mov	r0, r7
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a + t2_a;                                                     //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b + t2_b;                                                     //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
      t2_b &= MASCARA_SAT_B_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
                                                                                      //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);           //  11xx11xx11xx  * Moves all to its correct place.
    1034:	e1a09007 	mov	r9, r7
    1038:	e51bc058 	ldr	ip, [fp, #-88]
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
    103c:	e0017007 	and	r7, r1, r7
    1040:	e51b1064 	ldr	r1, [fp, #-100]
    1044:	e1a0e804 	mov	lr, r4, lsl #16
    1048:	e15c0824 	cmp	ip, r4, lsr #16
    104c:	e1a0e82e 	mov	lr, lr, lsr #16
    1050:	e1a0c801 	mov	ip, r1, lsl #16
    1054:	018c300e 	orreq	r3, ip, lr
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
    1058:	e50ba05c 	str	sl, [fp, #-92]
    105c:	e003a00a 	and	sl, r3, sl
    1060:	e59f209c 	ldr	r2, [pc, #156]	; 1104 <.text+0x1104>
    1064:	e0030000 	and	r0, r3, r0
    1068:	e1a032aa 	mov	r3, sl, lsr #5
    106c:	e59f6094 	ldr	r6, [pc, #148]	; 1108 <.text+0x1108>
    1070:	e50bc064 	str	ip, [fp, #-100]
      unsigned  t2_b = (c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G2__r2__b2
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a + t2_a;                                                     //  __RT__BT__gT  * T means Total
    1074:	e083c2a8 	add	ip, r3, r8, lsr #5
      t1_b  = t2_b = t1_b + t2_b;                                                     //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
    1078:	e00c1002 	and	r1, ip, r2
    107c:	e0800007 	add	r0, r0, r7
      t2_b &= MASCARA_SAT_B_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
    1080:	e04122a1 	sub	r2, r1, r1, lsr #5
    1084:	e0006006 	and	r6, r0, r6
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
    1088:	e18c3002 	orr	r3, ip, r2
    108c:	e04612a6 	sub	r1, r6, r6, lsr #5
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
    1090:	e51b205c 	ldr	r2, [fp, #-92]
    1094:	e1800001 	orr	r0, r0, r1
    1098:	e1a0c283 	mov	ip, r3, lsl #5
    109c:	e00c1002 	and	r1, ip, r2
                                                                                      //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);           //  11xx11xx11xx  * Moves all to its correct place.
    10a0:	e0009009 	and	r9, r0, r9
    10a4:	e51bc054 	ldr	ip, [fp, #-84]
    10a8:	e51b004c 	ldr	r0, [fp, #-76]
    10ac:	e1813009 	orr	r3, r1, r9
    10b0:	e78c3000 	str	r3, [ip, r0]
    10b4:	e2955001 	adds	r5, r5, #1	; 0x1
    10b8:	1a0003f1 	bne	2084 <.text+0x2084>
    10bc:	e51bc03c 	ldr	ip, [fp, #-60]
    10c0:	e51b0040 	ldr	r0, [fp, #-64]
    10c4:	e51b1060 	ldr	r1, [fp, #-96]
    10c8:	e51b204c 	ldr	r2, [fp, #-76]
    10cc:	e2413001 	sub	r3, r1, #1	; 0x1
    10d0:	e0821100 	add	r1, r2, r0, lsl #2
    10d4:	e51b2048 	ldr	r2, [fp, #-72]
    10d8:	e50b104c 	str	r1, [fp, #-76]
    10dc:	e3730001 	cmn	r3, #1	; 0x1
    10e0:	e082110c 	add	r1, r2, ip, lsl #2
    10e4:	e50b1048 	str	r1, [fp, #-72]
    10e8:	e50b3060 	str	r3, [fp, #-96]
    10ec:	1a0003ee 	bne	20ac <.text+0x20ac>
    10f0:	e50b3038 	str	r3, [fp, #-56]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_AddT>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, trans, 0);
}
    10f4:	e24bd028 	sub	sp, fp, #40	; 0x28
    10f8:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
    10fc:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
    1100:	07c0f83e 	undefined
    1104:	08020040 	stmeqda	r2, {r6}
    1108:	08010040 	stmeqda	r1, {r6}

0000110c <_Z15uS_DrawSpriteTAPtssS_ttt>:
    110c:	e1a0c00d 	mov	ip, sp
    1110:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
    1114:	e24cb004 	sub	fp, ip, #4	; 0x4
    1118:	e24dd04c 	sub	sp, sp, #76	; 0x4c
    111c:	e1db50b8 	ldrh	r5, [fp, #8]
    1120:	e1a0c802 	mov	ip, r2, lsl #16
    1124:	e1a01801 	mov	r1, r1, lsl #16
    1128:	e1db40bc 	ldrh	r4, [fp, #12]
    112c:	e24be034 	sub	lr, fp, #52	; 0x34
    1130:	e50b002c 	str	r0, [fp, #-44]
    1134:	e50b3030 	str	r3, [fp, #-48]
    1138:	e1a02841 	mov	r2, r1, asr #16
    113c:	e1a0384c 	mov	r3, ip, asr #16
    1140:	e50b5034 	str	r5, [fp, #-52]
    1144:	e58de000 	str	lr, [sp]
    1148:	e24b5038 	sub	r5, fp, #56	; 0x38
    114c:	e24be040 	sub	lr, fp, #64	; 0x40
    1150:	e24bc03c 	sub	ip, fp, #60	; 0x3c
    1154:	e24b002c 	sub	r0, fp, #44	; 0x2c
    1158:	e24b1030 	sub	r1, fp, #48	; 0x30
    115c:	e58d5004 	str	r5, [sp, #4]
    1160:	e58de00c 	str	lr, [sp, #12]
    1164:	e50b4038 	str	r4, [fp, #-56]
    1168:	e58dc008 	str	ip, [sp, #8]
    116c:	e1db50b4 	ldrh	r5, [fp, #4]
    1170:	ebfffffe 	bl	1170 <_Z15uS_DrawSpriteTAPtssS_ttt+0x64>
    1174:	e51be034 	ldr	lr, [fp, #-52]
    1178:	e35e0000 	cmp	lr, #0	; 0x0
    117c:	da0004c9 	ble	24a8 <.text+0x24a8>
    1180:	e51b3038 	ldr	r3, [fp, #-56]
    1184:	e3530000 	cmp	r3, #0	; 0x0
    1188:	da0004c9 	ble	24b4 <.text+0x24b4>
    118c:	e51b003c 	ldr	r0, [fp, #-60]
    1190:	e51b2040 	ldr	r2, [fp, #-64]
    1194:	e2434001 	sub	r4, r3, #1	; 0x1
    1198:	e51b3030 	ldr	r3, [fp, #-48]
    119c:	e1a0c0a0 	mov	ip, r0, lsr #1
    11a0:	e1a000a2 	mov	r0, r2, lsr #1
    11a4:	e1a0208e 	mov	r2, lr, lsl #1
    11a8:	e0823003 	add	r3, r2, r3
    11ac:	e50b304c 	str	r3, [fp, #-76]
    11b0:	e51b302c 	ldr	r3, [fp, #-44]
    11b4:	e1a010ce 	mov	r1, lr, asr #1
    11b8:	e2611000 	rsb	r1, r1, #0	; 0x0
    11bc:	e3740001 	cmn	r4, #1	; 0x1
    11c0:	e0822003 	add	r2, r2, r3
    11c4:	e1855805 	orr	r5, r5, r5, lsl #16
    11c8:	e50b1050 	str	r1, [fp, #-80]
    11cc:	e50bc03c 	str	ip, [fp, #-60]
    11d0:	e50b0040 	str	r0, [fp, #-64]
    11d4:	e50b2048 	str	r2, [fp, #-72]
    11d8:	e50b1034 	str	r1, [fp, #-52]
    11dc:	e50b5044 	str	r5, [fp, #-68]
    11e0:	e50b4058 	str	r4, [fp, #-88]
    11e4:	050b4038 	streq	r4, [fp, #-56]
    11e8:	0a0004c9 	beq	2514 <.text+0x2514>
    11ec:	e1a03805 	mov	r3, r5, lsl #16
    11f0:	e1a05823 	mov	r5, r3, lsr #16
    11f4:	e50b505c 	str	r5, [fp, #-92]
    11f8:	e51b5050 	ldr	r5, [fp, #-80]
    11fc:	e3550000 	cmp	r5, #0	; 0x0
    1200:	0a0004bd 	beq	24fc <.text+0x24fc>
    1204:	e51b2048 	ldr	r2, [fp, #-72]
    1208:	e51bc044 	ldr	ip, [fp, #-68]
    120c:	e7924105 	ldr	r4, [r2, r5, lsl #2]
    1210:	e1a01105 	mov	r1, r5, lsl #2
    1214:	e154000c 	cmp	r4, ip
    1218:	e50b1054 	str	r1, [fp, #-84]
    121c:	e1a03004 	mov	r3, r4
    1220:	e1a01804 	mov	r1, r4, lsl #16
    1224:	0a0004b9 	beq	2510 <.text+0x2510>
    1228:	e51b605c 	ldr	r6, [fp, #-92]
    122c:	e1a02824 	mov	r2, r4, lsr #16
    1230:	e1560821 	cmp	r6, r1, lsr #16
    1234:	e1a09802 	mov	r9, r2, lsl #16
    1238:	051b004c 	ldreq	r0, [fp, #-76]
    123c:	151b204c 	ldrne	r2, [fp, #-76]
    1240:	07901105 	ldreq	r1, [r0, r5, lsl #2]
    1244:	17921105 	ldrne	r1, [r2, r5, lsl #2]
    1248:	01a03801 	moveq	r3, r1, lsl #16
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
    124c:	e59fa0e0 	ldr	sl, [pc, #224]	; 1334 <.text+0x1334>
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
    1250:	e59f70e0 	ldr	r7, [pc, #224]	; 1338 <.text+0x1338>
    1254:	e1a0c821 	mov	ip, r1, lsr #16
    1258:	01a03823 	moveq	r3, r3, lsr #16
    125c:	e50bc064 	str	ip, [fp, #-100]
    1260:	01893003 	orreq	r3, r9, r3
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned)
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
    1264:	e001800a 	and	r8, r1, sl
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
      unsigned  t2_b = (c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G2__r2__b2
    1268:	e1a00007 	mov	r0, r7
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a + t2_a;                                                     //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b + t2_b;                                                     //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
      t2_b &= MASCARA_SAT_B_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
                                                                                      //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);           //  11xx11xx11xx  * Moves all to its correct place.
    126c:	e1a09007 	mov	r9, r7
    1270:	e51bc05c 	ldr	ip, [fp, #-92]
      //  SetUp:
      unsigned  t1_a = (c1 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R1__B1__g1
      unsigned  t2_a = (c2 & MASCARA_A_TWICE) >> BITS_BAJOS;                          //  __R2__B2__g2
  
      unsigned  t1_b = (c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G1__r1__b1
    1274:	e0017007 	and	r7, r1, r7
    1278:	e51b1064 	ldr	r1, [fp, #-100]
    127c:	e1a0e804 	mov	lr, r4, lsl #16
    1280:	e15c0824 	cmp	ip, r4, lsr #16
    1284:	e1a0e82e 	mov	lr, lr, lsr #16
    1288:	e1a0c801 	mov	ip, r1, lsl #16
    128c:	018c300e 	orreq	r3, ip, lr
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
    1290:	e50ba060 	str	sl, [fp, #-96]
    1294:	e003a00a 	and	sl, r3, sl
    1298:	e59f209c 	ldr	r2, [pc, #156]	; 133c <.text+0x133c>
    129c:	e0030000 	and	r0, r3, r0
    12a0:	e1a032aa 	mov	r3, sl, lsr #5
    12a4:	e59f6094 	ldr	r6, [pc, #148]	; 1340 <.text+0x1340>
    12a8:	e50bc064 	str	ip, [fp, #-100]
      unsigned  t2_b = (c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS);  //  __G2__r2__b2
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a + t2_a;                                                     //  __RT__BT__gT  * T means Total
    12ac:	e083c2a8 	add	ip, r3, r8, lsr #5
      t1_b  = t2_b = t1_b + t2_b;                                                     //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
    12b0:	e00c1002 	and	r1, ip, r2
    12b4:	e0800007 	add	r0, r0, r7
      t2_b &= MASCARA_SAT_B_TWICE;                                                    //  _1___1___1__  *** 1 appears ONLY where saturation happened.
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
    12b8:	e04122a1 	sub	r2, r1, r1, lsr #5
    12bc:	e0006006 	and	r6, r0, r6
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                          //  __11__11__11  *** 1 appears ONLY where saturation happened.
  
      t1_a |= t2_a;                                                                   //  __RSxxBSxxgS  * S means Saturated
    12c0:	e18c3002 	orr	r3, ip, r2
    12c4:	e04612a6 	sub	r1, r6, r6, lsr #5
      t1_b |= t2_b;                                                                   //  __GSxxrSxxbS  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                                 //  11xx11xx11xx  * Moves all to its correct place.
    12c8:	e51b2060 	ldr	r2, [fp, #-96]
    12cc:	e1800001 	orr	r0, r0, r1
    12d0:	e1a0c283 	mov	ip, r3, lsl #5
    12d4:	e00c1002 	and	r1, ip, r2
                                                                                      //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);           //  11xx11xx11xx  * Moves all to its correct place.
    12d8:	e0009009 	and	r9, r0, r9
    12dc:	e51bc054 	ldr	ip, [fp, #-84]
    12e0:	e51b004c 	ldr	r0, [fp, #-76]
    12e4:	e1813009 	orr	r3, r1, r9
    12e8:	e78c3000 	str	r3, [ip, r0]
    12ec:	e2955001 	adds	r5, r5, #1	; 0x1
    12f0:	1a00047f 	bne	24f4 <.text+0x24f4>
    12f4:	e51bc03c 	ldr	ip, [fp, #-60]
    12f8:	e51b0040 	ldr	r0, [fp, #-64]
    12fc:	e51b1058 	ldr	r1, [fp, #-88]
    1300:	e51b204c 	ldr	r2, [fp, #-76]
    1304:	e2413001 	sub	r3, r1, #1	; 0x1
    1308:	e0821100 	add	r1, r2, r0, lsl #2
    130c:	e51b2048 	ldr	r2, [fp, #-72]
    1310:	e50b104c 	str	r1, [fp, #-76]
    1314:	e3730001 	cmn	r3, #1	; 0x1
    1318:	e082110c 	add	r1, r2, ip, lsl #2
    131c:	e50b1048 	str	r1, [fp, #-72]
    1320:	e50b3058 	str	r3, [fp, #-88]
    1324:	1a00047c 	bne	251c <.text+0x251c>
    1328:	e50b3038 	str	r3, [fp, #-56]
    132c:	e24bd028 	sub	sp, fp, #40	; 0x28
    1330:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
    1334:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
    1338:	07c0f83e 	undefined
    133c:	08020040 	stmeqda	r2, {r6}
    1340:	08010040 	stmeqda	r1, {r6}

00001344 <_Z16uS_DrawSpriteHTSPtssS_t>:

void uS_DrawSpriteHTS ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans)
{
    1344:	e1a0c00d 	mov	ip, sp
    1348:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
    134c:	e24cb004 	sub	fp, ip, #4	; 0x4
    1350:	e24dd058 	sub	sp, sp, #88	; 0x58
    1354:	e1a0e000 	mov	lr, r0
    1358:	e1de50b4 	ldrh	r5, [lr, #4]
    135c:	e1de40b6 	ldrh	r4, [lr, #6]
    1360:	e1a00802 	mov	r0, r2, lsl #16
    1364:	e28ec00c 	add	ip, lr, #12	; 0xc
    1368:	e1a01801 	mov	r1, r1, lsl #16
    136c:	e24be034 	sub	lr, fp, #52	; 0x34
    1370:	e50b3030 	str	r3, [fp, #-48]
    1374:	e1a02841 	mov	r2, r1, asr #16
    1378:	e1a03840 	mov	r3, r0, asr #16
    137c:	e50bc02c 	str	ip, [fp, #-44]
    1380:	e50b5034 	str	r5, [fp, #-52]
    1384:	e58de000 	str	lr, [sp]
    1388:	e24b5038 	sub	r5, fp, #56	; 0x38
    138c:	e24be040 	sub	lr, fp, #64	; 0x40
    1390:	e24bc03c 	sub	ip, fp, #60	; 0x3c
    1394:	e24b002c 	sub	r0, fp, #44	; 0x2c
    1398:	e24b1030 	sub	r1, fp, #48	; 0x30
    139c:	e58d5004 	str	r5, [sp, #4]
    13a0:	e58de00c 	str	lr, [sp, #12]
    13a4:	e50b4038 	str	r4, [fp, #-56]
    13a8:	e58dc008 	str	ip, [sp, #8]
    13ac:	e1db50b4 	ldrh	r5, [fp, #4]
    13b0:	ebfffffe 	bl	13b0 <_Z16uS_DrawSpriteHTSPtssS_t+0x6c>
    13b4:	e51be034 	ldr	lr, [fp, #-52]
    13b8:	e35e0000 	cmp	lr, #0	; 0x0
    13bc:	da000560 	ble	2944 <.text+0x2944>
    13c0:	e51b3038 	ldr	r3, [fp, #-56]
    13c4:	e3530000 	cmp	r3, #0	; 0x0
    13c8:	da000560 	ble	2950 <.text+0x2950>
    13cc:	e51b003c 	ldr	r0, [fp, #-60]
    13d0:	e51b2040 	ldr	r2, [fp, #-64]
    13d4:	e2434001 	sub	r4, r3, #1	; 0x1
    13d8:	e51b3030 	ldr	r3, [fp, #-48]
    13dc:	e1a0c0a0 	mov	ip, r0, lsr #1
    13e0:	e1a000a2 	mov	r0, r2, lsr #1
    13e4:	e1a0208e 	mov	r2, lr, lsl #1
    13e8:	e0823003 	add	r3, r2, r3
    13ec:	e50b304c 	str	r3, [fp, #-76]
    13f0:	e51b302c 	ldr	r3, [fp, #-44]
    13f4:	e1a010ce 	mov	r1, lr, asr #1
    13f8:	e2611000 	rsb	r1, r1, #0	; 0x0
    13fc:	e3740001 	cmn	r4, #1	; 0x1
    1400:	e0822003 	add	r2, r2, r3
    1404:	e1855805 	orr	r5, r5, r5, lsl #16
    1408:	e50b1050 	str	r1, [fp, #-80]
    140c:	e50bc03c 	str	ip, [fp, #-60]
    1410:	e50b0040 	str	r0, [fp, #-64]
    1414:	e50b2048 	str	r2, [fp, #-72]
    1418:	e50b1034 	str	r1, [fp, #-52]
    141c:	e50b5044 	str	r5, [fp, #-68]
    1420:	e50b4068 	str	r4, [fp, #-104]
    1424:	050b4038 	streq	r4, [fp, #-56]
    1428:	0a000560 	beq	29b0 <.text+0x29b0>
    142c:	e1a03805 	mov	r3, r5, lsl #16
    1430:	e1a04823 	mov	r4, r3, lsr #16
    1434:	e50b405c 	str	r4, [fp, #-92]
    1438:	e51b4050 	ldr	r4, [fp, #-80]
    143c:	e3540000 	cmp	r4, #0	; 0x0
    1440:	0a000554 	beq	2998 <.text+0x2998>
    1444:	e51b1048 	ldr	r1, [fp, #-72]
    1448:	e51bc044 	ldr	ip, [fp, #-68]
    144c:	e7910104 	ldr	r0, [r1, r4, lsl #2]
    1450:	e1a05104 	mov	r5, r4, lsl #2
    1454:	e150000c 	cmp	r0, ip
    1458:	e50b5054 	str	r5, [fp, #-84]
    145c:	e1a03800 	mov	r3, r0, lsl #16
    1460:	e1a05000 	mov	r5, r0
    1464:	0a000550 	beq	29ac <.text+0x29ac>
    1468:	e51b605c 	ldr	r6, [fp, #-92]
    146c:	e1a08820 	mov	r8, r0, lsr #16
    1470:	e1560823 	cmp	r6, r3, lsr #16
    1474:	051b304c 	ldreq	r3, [fp, #-76]
    1478:	151bc04c 	ldrne	ip, [fp, #-76]
    147c:	07931104 	ldreq	r1, [r3, r4, lsl #2]
    1480:	179c1104 	ldrne	r1, [ip, r4, lsl #2]
    1484:	01a03801 	moveq	r3, r1, lsl #16
    1488:	e1a07808 	mov	r7, r8, lsl #16
    148c:	01a03823 	moveq	r3, r3, lsr #16
    1490:	01875003 	orreq	r5, r7, r3
    static  inline  unsigned Exe( unsigned c1, const unsigned c2, const unsigned)
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
    1494:	e59f30f4 	ldr	r3, [pc, #244]	; 1590 <.text+0x1590>
    1498:	e1a0c821 	mov	ip, r1, lsr #16
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
      unsigned  t2_a = ((c2 & MASCARA_A_TWICE) >> BITS_BAJOS);                                                //  __R2__B2__g2
  
      unsigned  t1_b = ((c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS)) | MASCARA_SAT_B_TWICE;  //  _1G1_1r1_1b1
    149c:	e59f20f0 	ldr	r2, [pc, #240]	; 1594 <.text+0x1594>
    14a0:	e50bc070 	str	ip, [fp, #-112]
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    14a4:	e59f60ec 	ldr	r6, [pc, #236]	; 1598 <.text+0x1598>
    14a8:	e001c003 	and	ip, r1, r3
    14ac:	e1a09003 	mov	r9, r3
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
  
      t1_a &= t2_a;                                                             //  __RUxxBUxxgU  * U means Underflow
      t1_b &= t2_b;                                                             //  __GUxxrSxxbU  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                           //  11xx11xx11xx  * Moves all to its correct place.
    14b0:	e50b3064 	str	r3, [fp, #-100]
    14b4:	e1a032ac 	mov	r3, ip, lsr #5
    14b8:	e183c006 	orr	ip, r3, r6
    14bc:	e1a08002 	mov	r8, r2
    14c0:	e0013002 	and	r3, r1, r2
                                                                                //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);     //  11xx11xx11xx  * Moves all to its correct place.
    14c4:	e50b2060 	str	r2, [fp, #-96]
    14c8:	e51b105c 	ldr	r1, [fp, #-92]
    14cc:	e51b2070 	ldr	r2, [fp, #-112]
    14d0:	e1a0e800 	mov	lr, r0, lsl #16
    14d4:	e1510820 	cmp	r1, r0, lsr #16
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
      unsigned  t2_a = ((c2 & MASCARA_A_TWICE) >> BITS_BAJOS);                                                //  __R2__B2__g2
  
      unsigned  t1_b = ((c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS)) | MASCARA_SAT_B_TWICE;  //  _1G1_1r1_1b1
    14d8:	e59fa0bc 	ldr	sl, [pc, #188]	; 159c <.text+0x159c>
    14dc:	e1a00802 	mov	r0, r2, lsl #16
    static  inline  unsigned Exe( unsigned c1, const unsigned c2, const unsigned)
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
    14e0:	e50bc058 	str	ip, [fp, #-88]
    14e4:	e1a0e82e 	mov	lr, lr, lsr #16
    14e8:	0180500e 	orreq	r5, r0, lr
      unsigned  t2_b = ((c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS));                        //  __G2__r2__b2
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
    14ec:	e51bc058 	ldr	ip, [fp, #-88]
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    14f0:	e1a0700a 	mov	r7, sl
    14f4:	e0059009 	and	r9, r5, r9
    14f8:	e183a00a 	orr	sl, r3, sl
    14fc:	e0058008 	and	r8, r5, r8
    1500:	e04c12a9 	sub	r1, ip, r9, lsr #5
    1504:	e50b0070 	str	r0, [fp, #-112]
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
    1508:	e068000a 	rsb	r0, r8, sl
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    150c:	e0016006 	and	r6, r1, r6
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    1510:	e0007007 	and	r7, r0, r7
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
    1514:	e04632a6 	sub	r3, r6, r6, lsr #5
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
    1518:	e04722a7 	sub	r2, r7, r7, lsr #5
  
      t1_a &= t2_a;                                                             //  __RUxxBUxxgU  * U means Underflow
    151c:	e001c003 	and	ip, r1, r3
      t1_b &= t2_b;                                                             //  __GUxxrSxxbU  * xx Garbage that appeared betwen the color components.
    1520:	e0000002 	and	r0, r0, r2
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                           //  11xx11xx11xx  * Moves all to its correct place.
    1524:	e51b3064 	ldr	r3, [fp, #-100]
                                                                                //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);     //  11xx11xx11xx  * Moves all to its correct place.
    1528:	e51b2060 	ldr	r2, [fp, #-96]
    152c:	e1a0128c 	mov	r1, ip, lsl #5
    1530:	e001c003 	and	ip, r1, r3
    1534:	e0001002 	and	r1, r0, r2
    1538:	e51b2054 	ldr	r2, [fp, #-84]
    153c:	e51b004c 	ldr	r0, [fp, #-76]
    1540:	e18c3001 	orr	r3, ip, r1
    1544:	e7823000 	str	r3, [r2, r0]
    1548:	e2944001 	adds	r4, r4, #1	; 0x1
    154c:	1a00050f 	bne	2990 <.text+0x2990>
    1550:	e51bc03c 	ldr	ip, [fp, #-60]
    1554:	e51b0040 	ldr	r0, [fp, #-64]
    1558:	e51b1068 	ldr	r1, [fp, #-104]
    155c:	e51b204c 	ldr	r2, [fp, #-76]
    1560:	e2413001 	sub	r3, r1, #1	; 0x1
    1564:	e0821100 	add	r1, r2, r0, lsl #2
    1568:	e51b2048 	ldr	r2, [fp, #-72]
    156c:	e50b104c 	str	r1, [fp, #-76]
    1570:	e3730001 	cmn	r3, #1	; 0x1
    1574:	e082110c 	add	r1, r2, ip, lsl #2
    1578:	e50b1048 	str	r1, [fp, #-72]
    157c:	e50b3068 	str	r3, [fp, #-104]
    1580:	1a00050c 	bne	29b8 <.text+0x29b8>
    1584:	e50b3038 	str	r3, [fp, #-56]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_SubT>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, trans, 0);
}
    1588:	e24bd028 	sub	sp, fp, #40	; 0x28
    158c:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
    1590:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
    1594:	07c0f83e 	undefined
    1598:	08020040 	stmeqda	r2, {r6}
    159c:	08010040 	stmeqda	r1, {r6}

000015a0 <_Z15uS_DrawSpriteTSPtssS_ttt>:
    15a0:	e1a0c00d 	mov	ip, sp
    15a4:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
    15a8:	e24cb004 	sub	fp, ip, #4	; 0x4
    15ac:	e24dd058 	sub	sp, sp, #88	; 0x58
    15b0:	e1db50b8 	ldrh	r5, [fp, #8]
    15b4:	e1a0c802 	mov	ip, r2, lsl #16
    15b8:	e1a01801 	mov	r1, r1, lsl #16
    15bc:	e1db40bc 	ldrh	r4, [fp, #12]
    15c0:	e24be034 	sub	lr, fp, #52	; 0x34
    15c4:	e50b002c 	str	r0, [fp, #-44]
    15c8:	e50b3030 	str	r3, [fp, #-48]
    15cc:	e1a02841 	mov	r2, r1, asr #16
    15d0:	e1a0384c 	mov	r3, ip, asr #16
    15d4:	e50b5034 	str	r5, [fp, #-52]
    15d8:	e58de000 	str	lr, [sp]
    15dc:	e24b5038 	sub	r5, fp, #56	; 0x38
    15e0:	e24be040 	sub	lr, fp, #64	; 0x40
    15e4:	e24bc03c 	sub	ip, fp, #60	; 0x3c
    15e8:	e24b002c 	sub	r0, fp, #44	; 0x2c
    15ec:	e24b1030 	sub	r1, fp, #48	; 0x30
    15f0:	e58d5004 	str	r5, [sp, #4]
    15f4:	e58de00c 	str	lr, [sp, #12]
    15f8:	e50b4038 	str	r4, [fp, #-56]
    15fc:	e58dc008 	str	ip, [sp, #8]
    1600:	e1db50b4 	ldrh	r5, [fp, #4]
    1604:	ebfffffe 	bl	1604 <_Z15uS_DrawSpriteTSPtssS_ttt+0x64>
    1608:	e51be034 	ldr	lr, [fp, #-52]
    160c:	e35e0000 	cmp	lr, #0	; 0x0
    1610:	da0005f5 	ble	2dec <.text+0x2dec>
    1614:	e51b3038 	ldr	r3, [fp, #-56]
    1618:	e3530000 	cmp	r3, #0	; 0x0
    161c:	da0005f5 	ble	2df8 <.text+0x2df8>
    1620:	e51b003c 	ldr	r0, [fp, #-60]
    1624:	e51b2040 	ldr	r2, [fp, #-64]
    1628:	e2434001 	sub	r4, r3, #1	; 0x1
    162c:	e51b3030 	ldr	r3, [fp, #-48]
    1630:	e1a0c0a0 	mov	ip, r0, lsr #1
    1634:	e1a000a2 	mov	r0, r2, lsr #1
    1638:	e1a0208e 	mov	r2, lr, lsl #1
    163c:	e0823003 	add	r3, r2, r3
    1640:	e50b304c 	str	r3, [fp, #-76]
    1644:	e51b302c 	ldr	r3, [fp, #-44]
    1648:	e1a010ce 	mov	r1, lr, asr #1
    164c:	e2611000 	rsb	r1, r1, #0	; 0x0
    1650:	e3740001 	cmn	r4, #1	; 0x1
    1654:	e0822003 	add	r2, r2, r3
    1658:	e1855805 	orr	r5, r5, r5, lsl #16
    165c:	e50b1050 	str	r1, [fp, #-80]
    1660:	e50bc03c 	str	ip, [fp, #-60]
    1664:	e50b0040 	str	r0, [fp, #-64]
    1668:	e50b2048 	str	r2, [fp, #-72]
    166c:	e50b1034 	str	r1, [fp, #-52]
    1670:	e50b5044 	str	r5, [fp, #-68]
    1674:	e50b405c 	str	r4, [fp, #-92]
    1678:	050b4038 	streq	r4, [fp, #-56]
    167c:	0a0005f5 	beq	2e58 <.text+0x2e58>
    1680:	e1a03805 	mov	r3, r5, lsl #16
    1684:	e1a04823 	mov	r4, r3, lsr #16
    1688:	e50b4060 	str	r4, [fp, #-96]
    168c:	e51b4050 	ldr	r4, [fp, #-80]
    1690:	e3540000 	cmp	r4, #0	; 0x0
    1694:	0a0005e9 	beq	2e40 <.text+0x2e40>
    1698:	e51b1048 	ldr	r1, [fp, #-72]
    169c:	e51bc044 	ldr	ip, [fp, #-68]
    16a0:	e7910104 	ldr	r0, [r1, r4, lsl #2]
    16a4:	e1a05104 	mov	r5, r4, lsl #2
    16a8:	e150000c 	cmp	r0, ip
    16ac:	e50b5054 	str	r5, [fp, #-84]
    16b0:	e1a03800 	mov	r3, r0, lsl #16
    16b4:	e1a05000 	mov	r5, r0
    16b8:	0a0005e5 	beq	2e54 <.text+0x2e54>
    16bc:	e51b6060 	ldr	r6, [fp, #-96]
    16c0:	e1a08820 	mov	r8, r0, lsr #16
    16c4:	e1560823 	cmp	r6, r3, lsr #16
    16c8:	051b304c 	ldreq	r3, [fp, #-76]
    16cc:	151bc04c 	ldrne	ip, [fp, #-76]
    16d0:	07931104 	ldreq	r1, [r3, r4, lsl #2]
    16d4:	179c1104 	ldrne	r1, [ip, r4, lsl #2]
    16d8:	01a03801 	moveq	r3, r1, lsl #16
    16dc:	e1a07808 	mov	r7, r8, lsl #16
    16e0:	01a03823 	moveq	r3, r3, lsr #16
    16e4:	01875003 	orreq	r5, r7, r3
    static  inline  unsigned Exe( unsigned c1, const unsigned c2, const unsigned)
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
    16e8:	e59f30f4 	ldr	r3, [pc, #244]	; 17e4 <.text+0x17e4>
    16ec:	e1a0c821 	mov	ip, r1, lsr #16
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
      unsigned  t2_a = ((c2 & MASCARA_A_TWICE) >> BITS_BAJOS);                                                //  __R2__B2__g2
  
      unsigned  t1_b = ((c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS)) | MASCARA_SAT_B_TWICE;  //  _1G1_1r1_1b1
    16f0:	e59f20f0 	ldr	r2, [pc, #240]	; 17e8 <.text+0x17e8>
    16f4:	e50bc070 	str	ip, [fp, #-112]
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    16f8:	e59f60ec 	ldr	r6, [pc, #236]	; 17ec <.text+0x17ec>
    16fc:	e001c003 	and	ip, r1, r3
    1700:	e1a09003 	mov	r9, r3
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
  
      t1_a &= t2_a;                                                             //  __RUxxBUxxgU  * U means Underflow
      t1_b &= t2_b;                                                             //  __GUxxrSxxbU  * xx Garbage that appeared betwen the color components.
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                           //  11xx11xx11xx  * Moves all to its correct place.
    1704:	e50b3068 	str	r3, [fp, #-104]
    1708:	e1a032ac 	mov	r3, ip, lsr #5
    170c:	e183c006 	orr	ip, r3, r6
    1710:	e1a08002 	mov	r8, r2
    1714:	e0013002 	and	r3, r1, r2
                                                                                //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);     //  11xx11xx11xx  * Moves all to its correct place.
    1718:	e50b2064 	str	r2, [fp, #-100]
    171c:	e51b1060 	ldr	r1, [fp, #-96]
    1720:	e51b2070 	ldr	r2, [fp, #-112]
    1724:	e1a0e800 	mov	lr, r0, lsl #16
    1728:	e1510820 	cmp	r1, r0, lsr #16
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
      unsigned  t2_a = ((c2 & MASCARA_A_TWICE) >> BITS_BAJOS);                                                //  __R2__B2__g2
  
      unsigned  t1_b = ((c1 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS)) | MASCARA_SAT_B_TWICE;  //  _1G1_1r1_1b1
    172c:	e59fa0bc 	ldr	sl, [pc, #188]	; 17f0 <.text+0x17f0>
    1730:	e1a00802 	mov	r0, r2, lsl #16
    static  inline  unsigned Exe( unsigned c1, const unsigned c2, const unsigned)
    {
      //  Separacion:
      //  SetUp:
      unsigned  t1_a = ((c1 & MASCARA_A_TWICE) >> BITS_BAJOS) | MASCARA_SAT_A_TWICE;                          //  _1R1_1B1_1g1
    1734:	e50bc058 	str	ip, [fp, #-88]
    1738:	e1a0e82e 	mov	lr, lr, lsr #16
    173c:	0180500e 	orreq	r5, r0, lr
      unsigned  t2_b = ((c2 & MASCARA_B_TWICE) << (MAXIMO_NUM_BITS_COLOR-BITS_BAJOS));                        //  __G2__r2__b2
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
    1740:	e51bc058 	ldr	ip, [fp, #-88]
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    1744:	e1a0700a 	mov	r7, sl
    1748:	e0059009 	and	r9, r5, r9
    174c:	e183a00a 	orr	sl, r3, sl
    1750:	e0058008 	and	r8, r5, r8
    1754:	e04c12a9 	sub	r1, ip, r9, lsr #5
    1758:	e50b0070 	str	r0, [fp, #-112]
  
      //  Suma_A:
      //  Suma_B:                                                     
      t1_a  = t2_a = t1_a - t2_a;                                               //  __RT__BT__gT  * T means Total
      t1_b  = t2_b = t1_b - t2_b;                                               //  __GT__rT__bT
    175c:	e068000a 	rsb	r0, r8, sl
  
      t2_a &= MASCARA_SAT_A_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    1760:	e0016006 	and	r6, r1, r6
      t2_b &= MASCARA_SAT_B_TWICE;                                              //  _1___1___1__  *** 1 appears ONLY where no underflow happened.
    1764:	e0007007 	and	r7, r0, r7
  
      t2_a -= (t2_a>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
    1768:	e04632a6 	sub	r3, r6, r6, lsr #5
      t2_b -= (t2_b>>MAXIMO_NUM_BITS_COLOR);                                    //  __11__11__11  *** 1 appears ONLY where no underflow happened.
    176c:	e04722a7 	sub	r2, r7, r7, lsr #5
  
      t1_a &= t2_a;                                                             //  __RUxxBUxxgU  * U means Underflow
    1770:	e001c003 	and	ip, r1, r3
      t1_b &= t2_b;                                                             //  __GUxxrSxxbU  * xx Garbage that appeared betwen the color components.
    1774:	e0000002 	and	r0, r0, r2
  
      t1_a  = (t1_a<<BITS_BAJOS) & (MASCARA_A_TWICE);                           //  11xx11xx11xx  * Moves all to its correct place.
    1778:	e51b3068 	ldr	r3, [fp, #-104]
                                                                                //  11__11__11__  * Cleans the space betwen components.   
      t1_b  = (t1_b>>MAXIMO_NUM_BITS_COLOR-BITS_BAJOS) & (MASCARA_B_TWICE);     //  11xx11xx11xx  * Moves all to its correct place.
    177c:	e51b2064 	ldr	r2, [fp, #-100]
    1780:	e1a0128c 	mov	r1, ip, lsl #5
    1784:	e001c003 	and	ip, r1, r3
    1788:	e0001002 	and	r1, r0, r2
    178c:	e51b2054 	ldr	r2, [fp, #-84]
    1790:	e51b004c 	ldr	r0, [fp, #-76]
    1794:	e18c3001 	orr	r3, ip, r1
    1798:	e7823000 	str	r3, [r2, r0]
    179c:	e2944001 	adds	r4, r4, #1	; 0x1
    17a0:	1a0005a4 	bne	2e38 <.text+0x2e38>
    17a4:	e51bc03c 	ldr	ip, [fp, #-60]
    17a8:	e51b0040 	ldr	r0, [fp, #-64]
    17ac:	e51b105c 	ldr	r1, [fp, #-92]
    17b0:	e51b204c 	ldr	r2, [fp, #-76]
    17b4:	e2413001 	sub	r3, r1, #1	; 0x1
    17b8:	e0821100 	add	r1, r2, r0, lsl #2
    17bc:	e51b2048 	ldr	r2, [fp, #-72]
    17c0:	e50b104c 	str	r1, [fp, #-76]
    17c4:	e3730001 	cmn	r3, #1	; 0x1
    17c8:	e082110c 	add	r1, r2, ip, lsl #2
    17cc:	e50b1048 	str	r1, [fp, #-72]
    17d0:	e50b305c 	str	r3, [fp, #-92]
    17d4:	1a0005a1 	bne	2e60 <.text+0x2e60>
    17d8:	e50b3038 	str	r3, [fp, #-56]
    17dc:	e24bd028 	sub	sp, fp, #40	; 0x28
    17e0:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
    17e4:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
    17e8:	07c0f83e 	undefined
    17ec:	08020040 	stmeqda	r2, {r6}
    17f0:	08010040 	stmeqda	r1, {r6}

000017f4 <_Z16uS_DrawSpriteHTBPtssS_th>:

void uS_DrawSpriteHTB ( u16 *sprite, short put_x, short put_y, u16 *framebuffer, u16 trans, u8 alpha)
{
    17f4:	e1a0c00d 	mov	ip, sp
    17f8:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
    17fc:	e24cb004 	sub	fp, ip, #4	; 0x4
    1800:	e24dd04c 	sub	sp, sp, #76	; 0x4c
    1804:	e1a05000 	mov	r5, r0
    1808:	e1d5e0b4 	ldrh	lr, [r5, #4]
    180c:	e24b9034 	sub	r9, fp, #52	; 0x34
    1810:	e1d540b6 	ldrh	r4, [r5, #6]
    1814:	e1a00802 	mov	r0, r2, lsl #16
    1818:	e285c00c 	add	ip, r5, #12	; 0xc
    181c:	e1a01801 	mov	r1, r1, lsl #16
    1820:	e58d9000 	str	r9, [sp]
    1824:	e5db9008 	ldrb	r9, [fp, #8]
    1828:	e50b3030 	str	r3, [fp, #-48]
    182c:	e1a02841 	mov	r2, r1, asr #16
    1830:	e1a03840 	mov	r3, r0, asr #16
    1834:	e50bc02c 	str	ip, [fp, #-44]
    1838:	e50be034 	str	lr, [fp, #-52]
    183c:	e24bc03c 	sub	ip, fp, #60	; 0x3c
    1840:	e24b5038 	sub	r5, fp, #56	; 0x38
    1844:	e24be040 	sub	lr, fp, #64	; 0x40
    1848:	e24b002c 	sub	r0, fp, #44	; 0x2c
    184c:	e24b1030 	sub	r1, fp, #48	; 0x30
    1850:	e98d1020 	stmib	sp, {r5, ip}
    1854:	e50b4038 	str	r4, [fp, #-56]
    1858:	e58de00c 	str	lr, [sp, #12]
    185c:	e1db50b4 	ldrh	r5, [fp, #4]
    1860:	e50b9044 	str	r9, [fp, #-68]
    1864:	ebfffffe 	bl	1864 <_Z16uS_DrawSpriteHTBPtssS_th+0x70>
    1868:	e51bc034 	ldr	ip, [fp, #-52]
    186c:	e35c0000 	cmp	ip, #0	; 0x0
    1870:	da000682 	ble	3280 <.text+0x3280>
    1874:	e51b3038 	ldr	r3, [fp, #-56]
    1878:	e3530000 	cmp	r3, #0	; 0x0
    187c:	da000682 	ble	328c <.text+0x328c>
    1880:	e51b003c 	ldr	r0, [fp, #-60]
    1884:	e51b2040 	ldr	r2, [fp, #-64]
    1888:	e2434001 	sub	r4, r3, #1	; 0x1
    188c:	e51b3030 	ldr	r3, [fp, #-48]
    1890:	e1a0e0a0 	mov	lr, r0, lsr #1
    1894:	e1a000a2 	mov	r0, r2, lsr #1
    1898:	e1a0208c 	mov	r2, ip, lsl #1
    189c:	e1a010cc 	mov	r1, ip, asr #1
    18a0:	e082c003 	add	ip, r2, r3
    18a4:	e51b302c 	ldr	r3, [fp, #-44]
    18a8:	e2611000 	rsb	r1, r1, #0	; 0x0
    18ac:	e3740001 	cmn	r4, #1	; 0x1
    18b0:	e0822003 	add	r2, r2, r3
    18b4:	e1855805 	orr	r5, r5, r5, lsl #16
    18b8:	e50b1050 	str	r1, [fp, #-80]
    18bc:	e50bc064 	str	ip, [fp, #-100]
    18c0:	e50be03c 	str	lr, [fp, #-60]
    18c4:	e50b0040 	str	r0, [fp, #-64]
    18c8:	e50b204c 	str	r2, [fp, #-76]
    18cc:	e50b1034 	str	r1, [fp, #-52]
    18d0:	e50b5048 	str	r5, [fp, #-72]
    18d4:	e50b4060 	str	r4, [fp, #-96]
    18d8:	050b4038 	streq	r4, [fp, #-56]
    18dc:	0a000682 	beq	32ec <.text+0x32ec>
    18e0:	e1a01805 	mov	r1, r5, lsl #16
    18e4:	e1a03821 	mov	r3, r1, lsr #16
    18e8:	e269c020 	rsb	ip, r9, #32	; 0x20
    18ec:	e50b3058 	str	r3, [fp, #-88]
    18f0:	e50bc05c 	str	ip, [fp, #-92]
    18f4:	e51bc050 	ldr	ip, [fp, #-80]
    18f8:	e35c0000 	cmp	ip, #0	; 0x0
    18fc:	0a000676 	beq	32dc <.text+0x32dc>
    1900:	e51b504c 	ldr	r5, [fp, #-76]
    1904:	e51b9048 	ldr	r9, [fp, #-72]
    1908:	e795410c 	ldr	r4, [r5, ip, lsl #2]
    190c:	e1a0e10c 	mov	lr, ip, lsl #2
    1910:	e1540009 	cmp	r4, r9
    1914:	e50be054 	str	lr, [fp, #-84]
    1918:	e1a05004 	mov	r5, r4
    191c:	e1a03804 	mov	r3, r4, lsl #16
    1920:	0a000672 	beq	32f0 <.text+0x32f0>
    1924:	e51ba058 	ldr	sl, [fp, #-88]
    1928:	e1a0e824 	mov	lr, r4, lsr #16
    192c:	e15a0823 	cmp	sl, r3, lsr #16
    1930:	051b3064 	ldreq	r3, [fp, #-100]
    1934:	151b9064 	ldrne	r9, [fp, #-100]
    1938:	e1a0880e 	mov	r8, lr, lsl #16
    193c:	0793e10c 	ldreq	lr, [r3, ip, lsl #2]
    1940:	1799e10c 	ldrne	lr, [r9, ip, lsl #2]
    1944:	01a0380e 	moveq	r3, lr, lsl #16
    1948:	e51b9058 	ldr	r9, [fp, #-88]
    
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
    194c:	e59f20c4 	ldr	r2, [pc, #196]	; 1a18 <.text+0x1a18>
    1950:	01a03823 	moveq	r3, r3, lsr #16
    1954:	e1a00804 	mov	r0, r4, lsl #16
    1958:	e1a0182e 	mov	r1, lr, lsr #16
    195c:	01885003 	orreq	r5, r8, r3
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
      tb += uAlpha * (c2 & MASCARA_B_TWICE);                                       //  __G2__r2__b2
    1960:	e59f70b4 	ldr	r7, [pc, #180]	; 1a1c <.text+0x1a1c>
    1964:	e1a03820 	mov	r3, r0, lsr #16
    1968:	e1590824 	cmp	r9, r4, lsr #16
    196c:	e1a01801 	mov	r1, r1, lsl #16
    1970:	01815003 	orreq	r5, r1, r3
    //		    c1; two 555x Colours thar will blend with c2 that contains anothe two 555x colours.
    //----------------------------------------------------------------------
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned uAlpha)
    {
      unsigned  ta = (c1 & MASCARA_A_TWICE)>>BITS_BAJOS;                          //  __R1__B1__g1
    1974:	e00e9002 	and	r9, lr, r2
      unsigned  tb = (c1 & MASCARA_B_TWICE);                                      //  __G1__r1__b1
    
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
      tb += uAlpha * (c2 & MASCARA_B_TWICE);                                       //  __G2__r2__b2
    1978:	e51b1044 	ldr	r1, [fp, #-68]
    197c:	e00e6007 	and	r6, lr, r7
    
      ta &=                    MASCARA_A_TWICE;                                   //  R2__B2__g2__
      ta += (tb>>BITS_BAJOS) & MASCARA_B_TWICE;                                   //  __G2__r2__b2
    1980:	e1a08007 	mov	r8, r7
    1984:	e1a0e2a9 	mov	lr, r9, lsr #5
    1988:	e0057007 	and	r7, r5, r7
    198c:	e0059002 	and	r9, r5, r2
    1990:	e51b0044 	ldr	r0, [fp, #-68]
    1994:	e1a0a002 	mov	sl, r2
    1998:	e0010197 	mul	r1, r7, r1
    199c:	e1a022a9 	mov	r2, r9, lsr #5
    19a0:	e0000092 	mul	r0, r2, r0
    19a4:	e51b305c 	ldr	r3, [fp, #-92]
    19a8:	e51b905c 	ldr	r9, [fp, #-92]
    19ac:	e0231396 	mla	r3, r6, r3, r1
    19b0:	e029099e 	mla	r9, lr, r9, r0
    19b4:	e1a012a3 	mov	r1, r3, lsr #5
    19b8:	e009a00a 	and	sl, r9, sl
    19bc:	e0018008 	and	r8, r1, r8
    19c0:	e51b3054 	ldr	r3, [fp, #-84]
    19c4:	e51b0064 	ldr	r0, [fp, #-100]
    19c8:	e08a2008 	add	r2, sl, r8
    19cc:	e7832000 	str	r2, [r3, r0]
    19d0:	e29cc001 	adds	ip, ip, #1	; 0x1
    19d4:	1a00063e 	bne	32d4 <.text+0x32d4>
    19d8:	e51be03c 	ldr	lr, [fp, #-60]
    19dc:	e51b0040 	ldr	r0, [fp, #-64]
    19e0:	e51b9060 	ldr	r9, [fp, #-96]
    19e4:	e51bc064 	ldr	ip, [fp, #-100]
    19e8:	e51b204c 	ldr	r2, [fp, #-76]
    19ec:	e2493001 	sub	r3, r9, #1	; 0x1
    19f0:	e08c1100 	add	r1, ip, r0, lsl #2
    19f4:	e3730001 	cmn	r3, #1	; 0x1
    19f8:	e082c10e 	add	ip, r2, lr, lsl #2
    19fc:	e50b1064 	str	r1, [fp, #-100]
    1a00:	e50bc04c 	str	ip, [fp, #-76]
    1a04:	e50b3060 	str	r3, [fp, #-96]
    1a08:	1a00063b 	bne	32fc <.text+0x32fc>
    1a0c:	e50b3038 	str	r3, [fp, #-56]
  SHEADER *pHdr = (SHEADER *)sprite;
  _DrawSprite<OP_BlendT>(sprite+6, framebuffer, put_x, put_y, pHdr->size_x, pHdr->size_y, trans, alpha);
}
    1a10:	e24bd028 	sub	sp, fp, #40	; 0x28
    1a14:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
    1a18:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
    1a1c:	07c0f83e 	undefined

00001a20 <_Z15uS_DrawSpriteTBPtssS_ttth>:
    1a20:	e1a0c00d 	mov	ip, sp
    1a24:	e92ddff0 	stmdb	sp!, {r4, r5, r6, r7, r8, r9, sl, fp, ip, lr, pc}
    1a28:	e24cb004 	sub	fp, ip, #4	; 0x4
    1a2c:	e24dd04c 	sub	sp, sp, #76	; 0x4c
    1a30:	e1dbe0b8 	ldrh	lr, [fp, #8]
    1a34:	e24b9034 	sub	r9, fp, #52	; 0x34
    1a38:	e1a0c802 	mov	ip, r2, lsl #16
    1a3c:	e1a01801 	mov	r1, r1, lsl #16
    1a40:	e1db40bc 	ldrh	r4, [fp, #12]
    1a44:	e58d9000 	str	r9, [sp]
    1a48:	e5db9010 	ldrb	r9, [fp, #16]
    1a4c:	e50b002c 	str	r0, [fp, #-44]
    1a50:	e50b3030 	str	r3, [fp, #-48]
    1a54:	e1a02841 	mov	r2, r1, asr #16
    1a58:	e1a0384c 	mov	r3, ip, asr #16
    1a5c:	e50be034 	str	lr, [fp, #-52]
    1a60:	e24bc03c 	sub	ip, fp, #60	; 0x3c
    1a64:	e24b5038 	sub	r5, fp, #56	; 0x38
    1a68:	e24be040 	sub	lr, fp, #64	; 0x40
    1a6c:	e24b002c 	sub	r0, fp, #44	; 0x2c
    1a70:	e24b1030 	sub	r1, fp, #48	; 0x30
    1a74:	e98d1020 	stmib	sp, {r5, ip}
    1a78:	e50b4038 	str	r4, [fp, #-56]
    1a7c:	e58de00c 	str	lr, [sp, #12]
    1a80:	e1db50b4 	ldrh	r5, [fp, #4]
    1a84:	e50b9044 	str	r9, [fp, #-68]
    1a88:	ebfffffe 	bl	1a88 <_Z15uS_DrawSpriteTBPtssS_ttth+0x68>
    1a8c:	e51bc034 	ldr	ip, [fp, #-52]
    1a90:	e35c0000 	cmp	ip, #0	; 0x0
    1a94:	da00070b 	ble	36c8 <.text+0x36c8>
    1a98:	e51b3038 	ldr	r3, [fp, #-56]
    1a9c:	e3530000 	cmp	r3, #0	; 0x0
    1aa0:	da00070b 	ble	36d4 <.text+0x36d4>
    1aa4:	e51b003c 	ldr	r0, [fp, #-60]
    1aa8:	e51b2040 	ldr	r2, [fp, #-64]
    1aac:	e2434001 	sub	r4, r3, #1	; 0x1
    1ab0:	e51b3030 	ldr	r3, [fp, #-48]
    1ab4:	e1a0e0a0 	mov	lr, r0, lsr #1
    1ab8:	e1a000a2 	mov	r0, r2, lsr #1
    1abc:	e1a0208c 	mov	r2, ip, lsl #1
    1ac0:	e1a010cc 	mov	r1, ip, asr #1
    1ac4:	e082c003 	add	ip, r2, r3
    1ac8:	e51b302c 	ldr	r3, [fp, #-44]
    1acc:	e2611000 	rsb	r1, r1, #0	; 0x0
    1ad0:	e3740001 	cmn	r4, #1	; 0x1
    1ad4:	e0822003 	add	r2, r2, r3
    1ad8:	e1855805 	orr	r5, r5, r5, lsl #16
    1adc:	e50b1050 	str	r1, [fp, #-80]
    1ae0:	e50bc064 	str	ip, [fp, #-100]
    1ae4:	e50be03c 	str	lr, [fp, #-60]
    1ae8:	e50b0040 	str	r0, [fp, #-64]
    1aec:	e50b204c 	str	r2, [fp, #-76]
    1af0:	e50b1034 	str	r1, [fp, #-52]
    1af4:	e50b5048 	str	r5, [fp, #-72]
    1af8:	e50b4058 	str	r4, [fp, #-88]
    1afc:	050b4038 	streq	r4, [fp, #-56]
    1b00:	0a00070b 	beq	3734 <.text+0x3734>
    1b04:	e1a01805 	mov	r1, r5, lsl #16
    1b08:	e1a03821 	mov	r3, r1, lsr #16
    1b0c:	e269c020 	rsb	ip, r9, #32	; 0x20
    1b10:	e50b305c 	str	r3, [fp, #-92]
    1b14:	e50bc060 	str	ip, [fp, #-96]
    1b18:	e51bc050 	ldr	ip, [fp, #-80]
    1b1c:	e35c0000 	cmp	ip, #0	; 0x0
    1b20:	0a0006ff 	beq	3724 <.text+0x3724>
    1b24:	e51be04c 	ldr	lr, [fp, #-76]
    1b28:	e51b9048 	ldr	r9, [fp, #-72]
    1b2c:	e79e410c 	ldr	r4, [lr, ip, lsl #2]
    1b30:	e1a0510c 	mov	r5, ip, lsl #2
    1b34:	e1540009 	cmp	r4, r9
    1b38:	e50b5054 	str	r5, [fp, #-84]
    1b3c:	e1a03804 	mov	r3, r4, lsl #16
    1b40:	e1a05004 	mov	r5, r4
    1b44:	0a0006fb 	beq	3738 <.text+0x3738>
    1b48:	e51ba05c 	ldr	sl, [fp, #-92]
    1b4c:	e1a0e824 	mov	lr, r4, lsr #16
    1b50:	e15a0823 	cmp	sl, r3, lsr #16
    1b54:	051b3064 	ldreq	r3, [fp, #-100]
    1b58:	151b9064 	ldrne	r9, [fp, #-100]
    1b5c:	e1a0880e 	mov	r8, lr, lsl #16
    1b60:	0793e10c 	ldreq	lr, [r3, ip, lsl #2]
    1b64:	1799e10c 	ldrne	lr, [r9, ip, lsl #2]
    1b68:	01a0380e 	moveq	r3, lr, lsl #16
    1b6c:	e51b905c 	ldr	r9, [fp, #-92]
    
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
    1b70:	e59f20c4 	ldr	r2, [pc, #196]	; 1c3c <.text+0x1c3c>
    1b74:	01a03823 	moveq	r3, r3, lsr #16
    1b78:	e1a00804 	mov	r0, r4, lsl #16
    1b7c:	e1a0182e 	mov	r1, lr, lsr #16
    1b80:	01885003 	orreq	r5, r8, r3
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
      tb += uAlpha * (c2 & MASCARA_B_TWICE);                                       //  __G2__r2__b2
    1b84:	e59f70b4 	ldr	r7, [pc, #180]	; 1c40 <.text+0x1c40>
    1b88:	e1a03820 	mov	r3, r0, lsr #16
    1b8c:	e1590824 	cmp	r9, r4, lsr #16
    1b90:	e1a01801 	mov	r1, r1, lsl #16
    1b94:	01815003 	orreq	r5, r1, r3
    //		    c1; two 555x Colours thar will blend with c2 that contains anothe two 555x colours.
    //----------------------------------------------------------------------
    static  inline  unsigned  Exe( const unsigned c1, const unsigned c2, const unsigned uAlpha)
    {
      unsigned  ta = (c1 & MASCARA_A_TWICE)>>BITS_BAJOS;                          //  __R1__B1__g1
    1b98:	e00e9002 	and	r9, lr, r2
      unsigned  tb = (c1 & MASCARA_B_TWICE);                                      //  __G1__r1__b1
    
      ta *= (32-uAlpha);
      tb *= (32-uAlpha);
    
      ta += uAlpha *((c2 & MASCARA_A_TWICE)>>(BITS_BAJOS));                        //  __R2__B2__g2
      tb += uAlpha * (c2 & MASCARA_B_TWICE);                                       //  __G2__r2__b2
    1b9c:	e51b1044 	ldr	r1, [fp, #-68]
    1ba0:	e00e6007 	and	r6, lr, r7
    
      ta &=                    MASCARA_A_TWICE;                                   //  R2__B2__g2__
      ta += (tb>>BITS_BAJOS) & MASCARA_B_TWICE;                                   //  __G2__r2__b2
    1ba4:	e1a08007 	mov	r8, r7
    1ba8:	e1a0e2a9 	mov	lr, r9, lsr #5
    1bac:	e0057007 	and	r7, r5, r7
    1bb0:	e0059002 	and	r9, r5, r2
    1bb4:	e51b0044 	ldr	r0, [fp, #-68]
    1bb8:	e1a0a002 	mov	sl, r2
    1bbc:	e0010197 	mul	r1, r7, r1
    1bc0:	e1a022a9 	mov	r2, r9, lsr #5
    1bc4:	e0000092 	mul	r0, r2, r0
    1bc8:	e51b3060 	ldr	r3, [fp, #-96]
    1bcc:	e51b9060 	ldr	r9, [fp, #-96]
    1bd0:	e0231396 	mla	r3, r6, r3, r1
    1bd4:	e029099e 	mla	r9, lr, r9, r0
    1bd8:	e1a012a3 	mov	r1, r3, lsr #5
    1bdc:	e009a00a 	and	sl, r9, sl
    1be0:	e0018008 	and	r8, r1, r8
    1be4:	e51b3054 	ldr	r3, [fp, #-84]
    1be8:	e51b0064 	ldr	r0, [fp, #-100]
    1bec:	e08a2008 	add	r2, sl, r8
    1bf0:	e7832000 	str	r2, [r3, r0]
    1bf4:	e29cc001 	adds	ip, ip, #1	; 0x1
    1bf8:	1a0006c7 	bne	371c <.text+0x371c>
    1bfc:	e51be03c 	ldr	lr, [fp, #-60]
    1c00:	e51b0040 	ldr	r0, [fp, #-64]
    1c04:	e51b9058 	ldr	r9, [fp, #-88]
    1c08:	e51bc064 	ldr	ip, [fp, #-100]
    1c0c:	e51b204c 	ldr	r2, [fp, #-76]
    1c10:	e2493001 	sub	r3, r9, #1	; 0x1
    1c14:	e08c1100 	add	r1, ip, r0, lsl #2
    1c18:	e3730001 	cmn	r3, #1	; 0x1
    1c1c:	e082c10e 	add	ip, r2, lr, lsl #2
    1c20:	e50b1064 	str	r1, [fp, #-100]
    1c24:	e50bc04c 	str	ip, [fp, #-76]
    1c28:	e50b3058 	str	r3, [fp, #-88]
    1c2c:	1a0006c4 	bne	3744 <.text+0x3744>
    1c30:	e50b3038 	str	r3, [fp, #-56]
    1c34:	e24bd028 	sub	sp, fp, #40	; 0x28
    1c38:	e89daff0 	ldmia	sp, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
    1c3c:	f83e07c0 	ldmnvda	lr!, {r6, r7, r8, r9, sl}
    1c40:	07c0f83e 	undefined
